Package: minimalErrorPkg
Title: Minimal error package
Type: Package
Version: 1.0
Date: 2012-04-11
Author: Toby Dylan Hocking 
Maintainer: Toby Dylan Hocking <toby.hocking@inria.fr>
Description: Try to figure out why inlinedocs gets an error.
 If this minimal package makes an error too, then it is
 probably not the fault of inlinedocs.
License: GPL-3

Package: inlinedocsTest
Title: Various functions to test inlinedocs
Type: Package
Version: 1.0-0
Encoding: latin1
Date: 2010-05-14
Author: Toby Dylan Hocking, Keith Ponting, Philippe Grosjean
Maintainer: Toby Dylan Hocking <toby.hocking@inria.fr>, Keith Ponting <k.ponting@aurix.com>
Description: Generates Rd files from R source code with comments, providing for quick, sustainable package development. The syntax keeps code and documentation close together, and is inspired by the Don't Repeat Yourself principle.
URL: http://inlinedocs.r-forge.r-project.org
Depends: methods, utils
Imports: tools
License: GPL-3
LazyLoad: yes

Package: inlinedocs
Title: Convert inline comments to documentation
Type: Package
Version: 2013.9.3
Authors@R: c(person("Toby Dylan","Hocking",role=c("aut","cre"),
	   email="toby@sg.cs.titech.ac.jp"),
	  person("Keith","Ponting",role="aut"),
	  person("Thomas","Wutzler",role="aut"),
	  person("Philippe","Grosjean",role="aut"),
	  person("Markus","Müller",role="aut"),
	  person("R Core Team",role=c("ctb","cph")))
Description: Generates Rd files from R source code with comments.
 The main features of the default syntax are that
 (1) docs are defined in comments near the relevant code,
 (2) function argument names are not repeated in comments, and
 (3) examples are defined in R code, not comments.
 It is also easy to define a new syntax.
URL: http://inlinedocs.r-forge.r-project.org
Depends: methods, utils, R (>= 2.9)
License: GPL-2 | GPL-3
LazyLoad: yes
Encoding: UTF-8
Packaged: 2013-09-03 07:45:07 UTC; toby
Author: Toby Dylan Hocking [aut, cre],
  Keith Ponting [aut],
  Thomas Wutzler [aut],
  Philippe Grosjean [aut],
  Markus Müller [aut],
  R Core Team [ctb, cph]
Maintainer: Toby Dylan Hocking <toby@sg.cs.titech.ac.jp>
NeedsCompilation: no
Repository: CRAN
Date/Publication: 2013-09-03 13:04:14
Built: R 3.5.1; ; 2018-10-23 13:54:52 UTC; windows

#scratch code for development of inlinedocs handling tabs and indentation

tmp.f <- function(){
	library(debug)
	setwd("inlinedocs/pkg/inlinedocs/tests")
	source("../R/package.skeleton.dx.R")
	prefix <- "^[ \t]*###[ \t]"			#changed the pattern to handle tabs at the beginning
	#mtrace(extract.docs.chunk)
	res <- suppressWarnings(test.pkg("indent"))
}

tmp.f2 <- function(){
	line="\t,third ,\t##<< an argument with comma before and online comment"
	arg.pat <- paste("^[^=#]*?([\\w\\.]+)\\s*([=,].*|\\)\\s*)?",
		"<<\\s*(\\S.*?)\\s*$",
		sep="##") # paste avoids embedded trigger fooling the system
	grep(arg.pat,line,perl=TRUE)
	gsub(arg.pat,"\\3",line,perl=TRUE);	#comment
	gsub(arg.pat,"\\\\item\\{\\1\\}",line,perl=TRUE) #arg
	
	(arg.pat <- paste("^[^=#]*?([\\w\\.]+)", sep="##"))
	arg.pat <- "[^[^=,#]*"
	arg.pat <- "[^[^=,#]*?"
}

### Prefix for code comments used with grep and gsub.
prefix <- "^### "

decomment <- function
### Remove comment prefix and join lines of code to form a
### documentation string.
(comments ##<< Character vector of prefixed comment lines.
 ){
  paste(gsub(prefix,"",comments),collapse=" ")
### String without prefixes or newlines.
}

### Necessary fields in DESCRIPTION, otherwise error.
fields <- c("Package","Maintainer","Author","Version",
            "License","Title","Description")
### Default DESCRIPTION, written if it doesn't exist.
empty.description <- matrix("",ncol=length(fields),dimnames=list(NULL,fields))

package.skeleton.dx <- function # Package skeleton deluxe
### Automates more of the setup process for a new source
### package. After inspecting the specified R code files to find
### inline documentation, it calls the standard package.skeleton
### function, which creates bare Rd files. The inline documentation is
### added to these Rd files and then these files are copied to
### ../man. It will overwrite files in the pkgdir/man directory.
(pkgdir="..",
### package directory where the DESCRIPTION file lives. Your code
### should be in pkgdir/R. We will setwd to pkgdir/R for the duration
### of the function, then switch back to where you were previously.
 code_files=NULL,
### Character vector with the names of the R code files, to be passed
### to package.skeleton, and also inspected for inline
### documentation. NULL means all files ending in .R.
 check=""
### Value indicating whether or not to check the package after
### documentation is built. Anything other than "" (the default) will
### check the package. "noex" means check the package without running
### examples, only tests (useful for debugging if your tests/examples
### take a long time).
 ){
  chdir <- file.path(pkgdir,"R")
  old.wd <- setwd(chdir)
  on.exit(setwd(old.wd))

  descfile <- file.path("..","DESCRIPTION")
  if(!file.exists(descfile)){
    write.dcf(empty.description,descfile)
    stop("Need ",descfile,"; please fill that in and try again")
  }

  ## Read description and check for errors
  desc <- read.dcf(descfile)
  for(f in fields){
    if(! f %in% colnames(desc))stop("Need ",f," in ",descfile)
    if(desc[,f]=="")stop("Need a value for ",f," in ",descfile)
  }

  ## extract docs from each file
  if(is.null(code_files))code_files <- Sys.glob("*.R")
  docs <- list()
  for(cf in code_files){
    L <- extract.docs.file(cf,check!="noex")
    for(N in names(L))docs[[N]] <- L[[N]]
  }
  for(i in names(docs)){
    docs[[i]]$`\\author` <- desc[,"Maintainer"]
    if(! '\\title' %in% names(docs[[i]]))
      docs[[i]]$`\\title` <- gsub("[._]"," ",i)
  }
  name <- desc[,"Package"]
  in.details <- setdiff(colnames(desc),"Description")
  details <- paste(paste(in.details,": \\tab ",desc[,in.details],"\\cr",sep=""),
                   collapse="\n")
  docs[[paste(name,"-package",sep="")]] <-
    list(`\\title`=desc[,"Title"],
         `\\description`=desc[,"Description"],
         `\\tabular{ll}`=details,
         `\\author`=desc[,"Maintainer"])
  ## Make package skeleton and edit Rd files
  unlink(name,rec=TRUE)
  package.skeleton(name,code_files=code_files)
  cat("Modifying files automatically generated by package.skeleton:\n")
  for(N in names(docs))modify.Rd.file(N,name,docs)
  file.copy(file.path(name,'man'),"..",rec=TRUE)
  unlink(name,rec=TRUE)

  if(check!=""){
    Rdir <- setwd(file.path("..",".."))
    cdir <- basename(dirname(Rdir))
    system(paste("R CMD check",cdir))
  }
  ## rebuild examples if we didn't test them:
  if(check=="noex")package.skeleton.dx(pkgdir,code_files,"")
}

modify.Rd.file <- function
### Add inline documentation from comments to an Rd file
### automatically-generated by package.skeleton.
(N,
### Name of function/file to which we will add documentation.
 pkg,
### Package name.
 docs
### Named list of documentation in extracted comments.
 ){
  fb <- paste(N,".Rd",sep="")
  f <- file.path(pkg,'man',fb)
  ## If there are no significant docs in the comments then the object
  ## should still be documented, by writing the file by hand in the
  ## man directory. This will write a blank Rd file if none exists, so
  ## it's easy to get started.
  if((length(docs[[N]])<3) &&
     file.exists(file.path("..","man",fb))){
    unlink(f)
    return()
  }
  cat(N,":",sep="")
  d <- docs[[N]]
  dlines <- readLines(f)

  ## cut out alias line if we are in the package file and there is a
  ## matching function
  if(length(grep("-package$",N)))
    dlines <- dlines[-grep(paste("alias[{]",N,sep=""),dlines)-1]

  ## cut out all comments {} interferes with regex matching
  dlines <- dlines[-grep("^[%~]",dlines)]

  ## cut out a couple of sections that cause warnings
  o <- grep("Optionally",dlines)
  if(length(o))dlines <- dlines[-(o:(o+1))]
  ## delete examples til the end of the file (also includes keywords)
  dlines <- dlines[1:(tail(grep("\\examples[{]$",dlines),1)-1)]
  ## add back a minimal examples section to find and replace
  dlines <- c(dlines,"\\examples{}")
  if ( "\\keyword" %in% names(d) ){
    dlines <- c(dlines,"\\keyword{}\n")
  }
  ## Find and replace based on data in d
  txt <- paste(dlines,collapse="\n")
  for(torep in names(d)){
    cat(" ",torep,sep="")
    FIND1 <- gsub("\\\\","\\\\\\\\",torep)
    FIND <- paste(gsub("([{}])","\\\\\\1",FIND1),"[{][^}]*[}]",sep="")
    ## need to escape backslashes for faithful copying of the comments
    ## to the Rd file:
    REP <- paste(FIND1,"{",gsub("\\\\","\\\\\\\\",d[[torep]]),"}",sep="")
    ## escape percent signs in R code:
    REP <- gsub("%","\\\\\\\\%",REP)
    txt <- gsub(FIND,REP,txt)
  }

  ## Fix usage
  m <- regexpr("usage[{][^}]*[}]",txt)
  Mend <- m+attr(m,"match.length")
  utxt <- substr(txt,m,Mend)
  if(length(grep("usage[{]data",utxt)))
     utxt <- gsub("data[(]([^)]*)[)]","\\1",utxt)
  ## add another backslash due to bug in package.skeleton
  txt <- paste(substr(txt,1,m-1),
               gsub("\\\\","\\\\\\\\",utxt),
               substr(txt,Mend+1,nchar(txt)),
               sep="")
  ## This doesn't work if there are quotes in the default values:
  ## gsub(",",paste("\n",paste(rep(" ",l=nchar(N)-1),collapse="")),utxt)
  cat(txt,file=f)
  cat("\n")
}

extract.docs.file <- function # Extract documentation from a file
### Parse an R code file and extract inline documentation from
### comments around each function.
(code.file,
### The R code file to parse.
 write.examples=TRUE
### Gather examples from test files?
 ){
  code <- readLines(code.file)
  comment.lines <- grep(prefix,code)
  e <- new.env()
  old <- options(keep.source.pkgs=TRUE)
  r <- try(sys.source(code.file,e),TRUE)
  if(class(r)=="try-error")
    stop("source ",code.file," failed with error:\n",r)
  options(old)
  objs <- sapply(ls(e),get,e,simplify=FALSE)
  extract.docs <- function(on){
    res <- try({
      o <- objs[[on]]
      doc <- if("function"%in%class(o)){
        tdoc <- extract.docs.fun(o)
        if(write.examples){ ## do not get examples from test files.
          tfile <- file.path("..","tests",paste(on,".R",sep=""))
          if(file.exists(tfile))
            tdoc[["\\examples"]] <- paste(readLines(tfile),collapse="\n")
        }
        tdoc
      }else list()
      ## Take the line before the first occurence of the variable
      defined.on <- grep(paste("^",on,sep=""),code)[1]-1
      if(!"description"%in%names(doc) && defined.on%in%comment.lines){
        comments.before <- comment.lines[comment.lines<=defined.on]
        these.comment.lines <- if(length(comments.before)==1)comments.before else{
          diffs <- diff(comments.before)
          comments.before[max(which(diffs>1))+1]:defined.on
        }
        doc$description <- decomment(code[these.comment.lines])
      }
      doc
    },FALSE)
    if(class(res)=="try-error"){
      cat("Failed to extract docs for: ",on,"\n\n")
      list()
    }
    else res
  }
  res <- sapply(names(objs),extract.docs,simplify=FALSE)
  res
### named list of lists. Each element is the result of a call to
### extract.docs.fun, with names corresponding to functions found in
### the R code file.
}

extract.docs.fun <- function # Extract documentation from a function
### Given a function, return a list describing inline documentation in
### the source of that function (relies on source attr).
(fun
### The function to examine.
 ){
  res <- list()
  code <- attr(fun,"source")
  clines <- grep("^#",code)
  if(length(grep("#",code[1])))res$`\\title` <- gsub("[^#]*#(.*)","\\1",code[1])
  if(length(clines)==0)return(res) ## no comments found
  bounds <- which(diff(clines)!=1)
  starts <- c(1,bounds+1)
  ends <- c(bounds,length(clines))
  for(i in seq_along(starts)){
    start <- clines[starts[i]]
    end <- clines[ends[i]]
    lab <- if(end+1==length(code))"\\value"
    else if(start==2)"\\description"
    else {
      arg <- gsub("^[\\s(]*","",code[start-1],perl=TRUE)
      arg <- gsub("^([\\w\\.]+).*","\\1",arg,perl=TRUE)
      arg <- gsub("...","\\dots",arg,fix=TRUE) ##special case for dots
      paste("\\item{",arg,"}",sep="")
    }
    res[[lab]] <- decomment(code[start:end])
  }
  ##<<details
  ## For simple functions/arguments, the argument may also be documented by
  ## appending ##<< comments on the same line as the argument. For those who
  ## wish to become confused, any following ### comment lines will be appended.
  arg.pat <- "^\\s*\\(?\\s*([\\w\\.]+).*##<<\\s*(\\S.*?)\\s*$"
  for ( k in 2:length(code) ){
    if ( 0 < length(grep(arg.pat,code[k],perl=TRUE)) ){
      arg <- gsub(arg.pat,"\\\\item\\{\\1\\}",code[k],perl=TRUE)
      comment <- gsub(arg.pat,"\\2",code[k],perl=TRUE);
      if ( is.null(res[[arg]]) ){
        res[[arg]] <- comment
      } else {
        res[[arg]] <- paste(comment,res[[arg]],sep=" ")
      }
    }
  }

  skeleton.fields <- c("alias","details","keyword","references","author",
                       "note","seealso","value")
  ##<<details
  ## Additionally, contiguous sections of ## comment lines beginning with
  ##<<xxx (where xxx is one of the "other" fields: alias, details, keyword,
  ## references, author, note, seealso or value) are accumulated and inserted in
  ## the relevant part of the .Rd file.
  ##
  ## In the case of value, the extra information is appended to that from
  ## any final ### comment lines.

  ## but this should not appear, because separated by a blank line
  extra.regexp <- paste("^\\s*##<<(",paste(skeleton.fields,collapse="|"),
                        ")\\s*(.*)$",sep="")
  starts.extra <- grep(extra.regexp,code,perl=TRUE)
  cont.re <- "^\\s*##\\s*";
  for ( start in starts.extra ){
    line <- code[start]
    field <- gsub(extra.regexp,"\\\\\\1",line,perl=TRUE)
    payload <- gsub(extra.regexp,"\\2",line,perl=TRUE)
    if ( start < length(code) ){
      for ( k in (start+1):length(code) ){
        if ( k %in% starts.extra        # go on to next extra section
            || 0 == length(grep(cont.re,code[k])) ){ # blank line or code ends
          if ( "\\alias" == field ){
            ##<<alias souped up function extraction
            ## extended keyword function commenting
            ##<<note Alias extras are automatically split at new lines.
            payload <- gsub("\\n+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          } else if ("\\keyword" == field ){
            ##<<keyword documentation utilities
            ##<<note Keyword extras are auto-split at white space.
            payload <- gsub("\\s+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          }
          ##<<details Each separate extra section appears as a new paragraph
          ## except that empty sections (no matter how many lines) are ignored.
          if ( 0 == length(grep("^\\s*$",payload,perl=TRUE)) ){
            if ( is.null(res[[field]]) ){
              res[[field]] <- payload
            } else {
              res[[field]] <- paste(res[[field]], payload, sep="\n\n")
            }
          }
          break;
        } else {
          payload <- paste(payload,sub(cont.re,"",code[k],perl=TRUE),sep="\n")
        }
      }
    }
  }
  res
### Named list of character strings extracted from comments. For each
### name N we will look for N\{...\} in the Rd file and replace it
### with the string in this list (implemented in modify.Rd.file).
}

silly.example <- function
### this function does nothing in particular and does it very well
(
 ##title<<Simple function arguments
 first,         ##<< the first argument with a multi-line description
 ## which I really have to put here rather than explaining in the details.
 second=        ##<< the second argument with a list default value
 ## and descriptions of each of the elements
 ##describe<<
 list(this="that", ##<< whichness
      the="other", ##<< of the
      rhubarb="stew", ##<< why
      foo="bar"),
 ##end<<
 third ##<< an argument that does nothing
 )
{
  ##description<<why should I add to description?
  ##details<<
  ## if second is TRUE then first is returned
  if ( second ){
    ##alias<<Long silly alias
    res <- first
  } else {
    ##details<<
    ## if second is not TRUE then a list is returned
    ##describe<<The contents of the list are:
    res <- list(x=7, ##<< x coordinate
                z= ##<< z describes everything else
                ##describe<<
                list(colour=green, ##<< colour of line
                     width=2),     ##<< width of line
                ##end<<
                ## and this line should get into documentation for z
                y=10)##<< y coordinate
  }
  ##note<< a note
  ##references<< a reference
  ##seealso<< \code{\link{Silly-class}}
  ##keyword<<documentation utilities
  invisible(res)
### invisible something not unrelated to first
}

setClass("Silly", # S4 classes can be documented as well
### The Silly class does nothing much either
         ##details<< Put what you like in documentation details,
         ## but ideally reference construction methods.
         representation(forwards="function", ##<< forward operation
                        reverse="function", ##<< how to go backward
                        crashes="integer") ##<< how many crashes
         ) ##<< this comment is ignored as it is outside setClass expression

## creates "show" generic function. Documentation of this not yet supported.
##setMethod("show","Silly",function(object){cat("crashed ",object@crashes," times\n")})

library(tools)
parsed <- parse_Rd("../man/package.skeleton.dx.Rd")
cleantags <- function(x)gsub("\\\\","",tools:::RdTags(x))
names(parsed) <- cleantags(parsed)
## all base-level TEXT tags are just whitespace...
stopifnot(all(parsed[names(parsed)=="TEXT"]=="\n"))
tl <- parsed[names(parsed)!="TEXT"]
arg <- tl[[which(names(tl)=="arguments")]]
names(arg) <- cleantags(arg)
arg <- arg[names(arg)!="TEXT"]
docs <-
  lapply(arg,function(L)paste(tools:::as.character.Rd(L[[2]]),collapse=""))
names(docs) <-
  sprintf("item{%s}",sapply(arg,function(L)tools:::as.character.Rd(L[[1]])))
docs <- c(docs,lapply(tl[names(tl)!="arguments"],paste,collapse=""))
library(inlinedocs)
ext <- extract.docs.file("../R/package.skeleton.dx.R")$package.skeleton.dx
## ignore definition and format
for(N in names(ext)){
  cat(N,":")
  if(N %in% names(docs)){
    if(ext[[N]]!=docs[[N]])cat("MISMATCH!!!")
  }else cat("does not exist in Rd!!!")
  cat("\n")
}

## bt_jannis@yahoo.de



## I have a problem when I use functions as default values for argumnents
## in other functions. When I use curly brackets { here, I can not create a
## package with inlinedocs. It will give me the error when using
## package.skeleton() in my package structure:

## Error in parse(text = utxt) : <text>:4:0: unexpected end of input


## For example:

dummyfunction = function(filters = function(x) {b = 0; x > b} )
{
   # rest of code here
   return(filters)
}


## This seems to me as a legal function declaration but creates the above
## mentioned error. Is this an error of inlinedocs or do I misunderstand
## the R language? Or is there another way of using functions in such a way
## as arguments? In this case I could easily define this filters argument
## inside the function for cases when it is not supplied as an argument but
## I have some more complex functions where I really need to define
## something sequential as an argument like:

## dummyfunction = function(filters = {a = 1; b > a; b}) {print('test')}

f <- function # title
### description
(x, ##<< arg x
 y
### arg y
 ){
  ##value<< a list with elements
  list(x=x, ##<< original x value
       y=y, ##<< original y value
       sum=x+y) ##<< their sum
  ##end<<
}

.result <- 
 list(f = list(definition = "f <- function # title\n### description\n(x, ##<< arg x\n y\n### arg y\n ){\n  ##value<< a list with elements\n  list(x=x, ##<< original x value\n       y=y, ##<< original y value\n       sum=x+y) ##<< their sum\n  ##end<<\n}",  
     description = "description", `item{y}` = "arg y", `item{x}` = "arg x",  
     value = "a list with elements\n\\item{x}{original x value}\n\\item{y}{original y value}\n\\item{sum}{their sum}",  
     title = "title", format = "")) 

CalculateSampleCovariance <- function(x, y, verbose = TRUE) {
  # Computes the sample covariance between two vectors.
  #
  # Args:
  #   x: One of two vectors whose sample covariance is to be calculated.
  #   y: The other vector. x and y must have the same length, greater than one,
  #      with no missing values.
  #   verbose: If TRUE, prints sample covariance; if not, not. Default is TRUE.
  #
  # Returns:
  #   The sample covariance between x and y.
  n <- length(x)
  # Error handling
  if (n <= 1 || n != length(y)) {
    stop("Arguments x and y have invalid lengths: ",
         length(x), " and ", length(y), ".")
  }
  if (TRUE %in% is.na(x) || TRUE %in% is.na(y)) {
    stop(" Arguments x and y must not have missing values.")
  }
  covariance <- var(x, y)
  if (verbose)
    cat("Covariance = ", round(covariance, 4), ".\n", sep = "")
  return(covariance)
}

str_match_perl <- function(string,pattern){
  parsed <- regexpr(pattern,string,perl=TRUE)
  names <- attr(parsed,"capture.names")
  captured.text <- substr(string,parsed,parsed+attr(parsed,"match.length")-1)
  captured.text[captured.text==""] <- NA
  captured.groups <- do.call(rbind,lapply(seq_along(string),function(i){
    if(is.na(parsed[i]) || parsed[i]==-1)return(rep(NA,length(names)))
    st <- attr(parsed,"capture.start")[i,]
    substring(string[i],st,st+attr(parsed,"capture.length")[i,]-1)
  }))
  result <- cbind(captured.text,captured.groups)
  colnames(result) <- c("",names)
  result
}

str_match_all_perl <- function(string,pattern){
  parsed <- gregexpr(pattern,string,perl=TRUE)
  lapply(seq_along(parsed),function(i){
    r <- parsed[[i]]
    starts <- attr(r,"capture.start")
    if(r[1]==-1)return(matrix(nrow=0,ncol=1+ncol(starts)))
    names <- attr(r,"capture.names")
    lengths <- attr(r,"capture.length")
    full <- substring(string[i],r,r+attr(r,"match.length")-1)
    subs <- substring(string[i],starts,starts+lengths-1)
    m <- matrix(c(full,subs),ncol=length(names)+1)
    colnames(m) <- c("",names)
    m
  })
}


google <- function(src,...){
  # Extract docs from google header comments.
  #
  # Args:
  # src: lines of code of the function source.
  #
  # Returns:
  # An inner Documentation List.
  pre <- "\\W*#\\W+"
  lines.pat <- paste("(?:",pre,".*?\n)+",sep="")
  google.doc.pattern <-
    paste("(?<description>",lines.pat,")",
          pre,"Args:\\W*\n",
          "(?<args>",lines.pat,")",
          pre,"Returns:\\W*\n",
          "(?<value>",lines.pat,")",
          sep="")
  lines <- paste(src,collapse="\n")
  parsed <- str_match_perl(lines,google.doc.pattern)
  if(is.na(parsed[1]))return(list())
  docs <- list(description=gsub(pre,"",parsed[,"description"]),
               value=gsub(pre,"",parsed[,"value"]))
  arg.pat <-
    paste(pre,"(?<name>[a-z]+): ",
          "(?<content>.*?\n",
          "(?:",pre,"[^:]*?\n)*)",
          sep="")
  m <- str_match_all_perl(parsed[,"args"],arg.pat)[[1]]
  argsList <- as.list(gsub(paste("\n",pre,sep=""),"\n",m[,"content"]))
  names(argsList) <- sprintf("item{%s}",m[,"name"])
  lapply(c(docs,argsList),function(x)gsub("\n$","",x))
}

.parsers <- list(google=forfun(google))

##src <- getSource(CalculateSampleCovariance)
## src <- getSource(google)
## src <- getSource(str_match_all_perl)
## google(src)

.dontcheck <- TRUE

.result <-
  list(google=list(description="Extract docs from google header comments.",
         `item{src}`="lines of code of the function source.",
         value="An inner Documentation List."),
       str_match_all_perl=list(),
       str_match_perl=list(),
       CalculateSampleCovariance=list(
         description="Computes the sample covariance between two vectors.",
         `item{x}`="One of two vectors whose sample covariance is to be calculated.",
         `item{y}`="The other vector. x and y must have the same length, greater than one,\nwith no missing values.",
         `item{verbose}`="If TRUE, prints sample covariance; if not, not. Default is TRUE.",
         value="The sample covariance between x and y."))

outer.function <- function
### this is a high-level package function that will be exported for
### all of your users.
(a,
### first arg
 b
### second arg
 ) {
  foo <- a
  inner.function <- function
  ## This is a internal function only used inside outer.function, thus
  ## package users will not be able to access it. However we should
  ## still be able to document it like this.
  (x
   ## Some argument of the inner function.
   ) {
    y <- x
    ## Return value of the inner function.
  }
  bar <- b
### Return value of outer.function.
}

fermat.test <- function
### Test an integer for primality using Fermat's Little Theorem.
(n ##<< The integer to test.
 ){
  a <- floor(runif(1,min=1,max=n))
  a^n %% n == a
### Whether the integer passes the Fermat test for a randomized
### \eqn{0<a<n}.
}
is.pseudoprime <- function # Check an integer for pseudo-primality.
### A number is pseudo-prime if it is probably prime, the basis of
### which is the probabalistic Fermat test; if it passes two such
### tests, the chances are better than 3 out of 4 that \eqn{n} is
### prime.
##references<< Abelson, Hal; Jerry Sussman, and Julie
##Sussman. Structure and Interpretation of Computer
##Programs. Cambridge: MIT Press, 1984.
(n,    ##<< Integer to test for pseudoprimality.
 times
### Number of Fermat tests to perform. More tests are more likely to
### give accurate results.
 ){
  if(times==0)TRUE
  ##seealso<< \code{\link{fermat.test}}
  else if(fermat.test(n)) is.pseudoprime(n,times-1)
  else FALSE
### logical TRUE if n is probably prime.
}
try.several.times <- structure(function
### Test an integer for primality using different numbers of tests.
(n,    ##<< integer to test for primality.
 times ##<< vector of number of tests to try.
 ){
  is.prime <- sapply(times,function(t)is.pseudoprime(n,t))
  ##value<< data.frame with columns:
  data.frame(times, ##<< number of Fermat tests.
             is.prime, ##<< TRUE if probably prime
             n) ##<< Integer tested.
  ##end<<
},ex=function(){
  try.several.times(6,1:5)
  try.several.times(5,1:5)
})
setClass("DocLink", # Link documentation among related functions
### The \code{DocLink} class provides the basis for hooking together
### documentation of related classes/functions/objects. The aim is that
### documentation sections missing from the child are inherited from
### the parent class.
    representation(name = "character", ##<< name of object
                   created = "character", ##<< how created
                   parent = "character", ##<< parent class or NA
                   code = "character", ##<< actual source lines
                   description = "character") ##<< preceding description block
         )

.result <- 
 list(fermat.test = list(definition = "fermat.test <- function\n### Test an integer for primality using Fermat's Little Theorem.\n(n ##<< The integer to test.\n ){\n  a <- floor(runif(1,min=1,max=n))\n  a^n %% n == a\n### Whether the integer passes the Fermat test for a randomized\n### \\eqn{0<a<n}.\n}",  
     description = "Test an integer for primality using Fermat's Little Theorem.",  
     value = "Whether the integer passes the Fermat test for a randomized\n\\eqn{0<a<n}.",  
     `item{n}` = "The integer to test.", format = "", title = "fermat test"),  
     is.pseudoprime = list(definition = "is.pseudoprime <- function # Check an integer for pseudo-primality.\n### A number is pseudo-prime if it is probably prime, the basis of\n### which is the probabalistic Fermat test; if it passes two such\n### tests, the chances are better than 3 out of 4 that \\eqn{n} is\n### prime.\n##references<< Abelson, Hal; Jerry Sussman, and Julie\n##Sussman. Structure and Interpretation of Computer\n##Programs. Cambridge: MIT Press, 1984.\n(n,    ##<< Integer to test for pseudoprimality.\n times\n### Number of Fermat tests to perform. More tests are more likely to\n### give accurate results.\n ){\n  if(times==0)TRUE\n  ##seealso<< \\code{\\link{fermat.test}}\n  else if(fermat.test(n)) is.pseudoprime(n,times-1)\n  else FALSE\n### logical TRUE if n is probably prime.\n}",  
         description = "A number is pseudo-prime if it is probably prime, the basis of\nwhich is the probabalistic Fermat test; if it passes two such\ntests, the chances are better than 3 out of 4 that \\eqn{n} is\nprime.",  
         `item{times}` = "Number of Fermat tests to perform. More tests are more likely to\ngive accurate results.",  
         value = "logical TRUE if n is probably prime.", references = "Abelson, Hal; Jerry Sussman, and Julie\nSussman. Structure and Interpretation of Computer\nPrograms. Cambridge: MIT Press, 1984.",  
         `item{n}` = "Integer to test for pseudoprimality.", seealso = "\\code{\\link{fermat.test}}",  
         title = "Check an integer for pseudo-primality.", format = ""),  
     try.several.times = list(definition = "try.several.times <- structure(function\n### Test an integer for primality using different numbers of tests.\n(n,    ##<< integer to test for primality.\n times ##<< vector of number of tests to try.\n ){\n  is.prime <- sapply(times,function(t)is.pseudoprime(n,t))\n  ##value<< data.frame with columns:\n  data.frame(times, ##<< number of Fermat tests.\n             is.prime, ##<< TRUE if probably prime\n             n) ##<< Integer tested.\n  ##end<<\n},ex=function(){\n  try.several.times(6,1:5)\n  try.several.times(5,1:5)\n})",  
         description = "Test an integer for primality using different numbers of tests.",  
         `item{n}` = "integer to test for primality.", `item{times}` = "vector of number of tests to try.",  
         value = "data.frame with columns:\n\\item{times}{number of Fermat tests.}\n\\item{is.prime}{TRUE if probably prime}\n\\item{n}{Integer tested.}",  
         format = "", title = "try several times", examples = "\ntry.several.times(6,1:5)\ntry.several.times(5,1:5)\n"),  
     `DocLink-class` = list(`item{name}` = "name of object", `item{created}` = "how created",  
         `item{parent}` = "parent class or NA", `item{code}` = "actual source lines",  
         `item{description}` = "preceding description block",  
         description = "The \\code{DocLink} class provides the basis for hooking together\ndocumentation of related classes/functions/objects. The aim is that\ndocumentation sections missing from the child are inherited from\nthe parent class.",  
         title = "Link documentation among related functions",  
         details = "Objects can be created by calls of the form \\code{new(DocLink ...)}",  
         `section{Objects from the Class}` = "Objects can be created by calls of the form \\code{new(DocLink ...)}",  
         seealso = "", alias = "DocLink", format = "")) 

### Takes the description from read.dcf and returns the Author line.
author.from.author <- function(desc,...){
  list(author=desc[,"Author"])
### Returns a list with named values that will be used to add
### documentation to Rd files.
}
## author.from.description is the name of the default parser for the
## author section. We copy all the other parsers functions in the
## list, then add our custom author parser to the end of the list.
my.parsers <-
  c(default.parsers["author.from.description"!=names(default.parsers)],
    forall(author.from.author))
## forall(FUN) returns a function that will apply FUN to all
## documentation objects in your package. Likewise, forfun(FUN) will
## apply FUN to all functions in your package.
package.skeleton.dx("/path/to/my/pkgdir",my.parsers)

A <- function(object){
  x
}
`A<-` <- function(object,...){
  x
}


# accessor
setMethod(f = "A",
          signature = "IcaSet" ,
          definition = function (object){
              return (object@A)
          }
          )

# set value of attribute A
setReplaceMethod(
      f = "A" ,
      signature = "IcaSet" ,
      definition = function (object, value, valid = TRUE){
        object@A <- value
        if (valid)
            validObject (object)
        return (object)
     }
)

library(inlinedocs)
str_match_all_perl <- function(string,pattern){
  parsed <- gregexpr(pattern,string,perl=TRUE)
  lapply(seq_along(parsed),function(i){
    r <- parsed[[i]]
    starts <- attr(r,"capture.start")
    if(r[1]==-1)return(matrix(nrow=0,ncol=1+ncol(starts)))
    names <- attr(r,"capture.names")
    lengths <- attr(r,"capture.length")
    full <- substring(string[i],r,r+attr(r,"match.length")-1)
    subs <- substring(string[i],starts,starts+lengths-1)
    m <- matrix(c(full,subs),ncol=length(names)+1)
    colnames(m) <- c("",names)
    m
  })
}

anne.setMethod <- function(code,...){
  re <- paste('#\\s*(?<description>.*?)\\s*',
              'set(?<replace>Replace)?Method[(]\\s*',
              'f\\s*=\\s*"(?<f>.*?)"\\s*,',
              '\\s*signature\\s*=\\s*"(?<signature>.*?)"',
              sep="")
  txt <- paste(code,collapse="\n")
  extracted <- str_match_all_perl(txt,re)[[1]][,-1]
  rownames(extracted) <-
    ifelse(extracted[,"replace"]=="Replace","method","replace")
  print(extracted)
  list("A_--methods"=as.list(extracted["replace",]),
       "A-methods"=as.list(extracted["method",]))
}

custom.parsers <- list(anne.setMethod=anne.setMethod)

## we assume anne.R is in the current directory, with some setMethod
## definitions.
extract.docs.file("anne.R",custom.parsers)

# then run inlinedocs on your package like this
package.skeleton.dx("annepkg",c(custom.parsers))

simple <- function(src,...){#title a simple Parser Function
  noquotes <- gsub("([\"'`]).*\\1","",src)
  print(noquotes)
  comments <- grep("#",noquotes,value=TRUE)
  pat <- "[^#]*#([^ ]*) (.*)"
  tags <- gsub(pat,"\\1",comments)
  docs <- as.list(gsub(pat,"\\2",comments))
  names(docs) <- tags
  docs[tags!=""]#value all the tags with a single pound sign
}

.parsers <- list(simple=forfun(simple))

testfun <- function(x,y,z){#item{x} the first arg
  a <- (x+y)*z # just a regular comment
  a #value the sum of the first two times the third
  #description a useless formula
}

.result <- list(testfun=list(`item{x}`="the first arg",
                  value="the sum of the first two times the third",
                  description="a useless formula"),
                simple=list(title="a simple Parser Function",
                  value="all the tags with a single pound sign"))

.dontcheck <- TRUE # because of use of forfun here

test <- function # simple function arguments
## this function does nothing in particular and does it very well
( first,         ##<< the first argument
  second=TRUE    ##<< the second argument
 ){
  ##<<alias Iolanthe
  ##<<details
  ## if second is TRUE then first is returned
  if ( second ){
    res <- first
  } else {
    ##<<details
    ## if second is not TRUE then first is negated
    res <- !first
  }
  invisible(res)
### invisible something not unrelated to first
}

fermat.test <- function#Test an integer for primality with Fermat's little theorem.
### Fermat's little theorem states that if \eqn{n} is a prime number
### and \eqn{a} is any positive integer less than \eqn{n}, then
### \eqn{a} raised to the \eqn{n}th power is congruent to \eqn{a\
### modulo\ n}{a modulo n}.
##references<< \url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}
(n ##<< the integer to test for primality.
 ){
  a <- floor(runif(1,min=1,max=n))
  ##note<< \code{fermat.test} doesn't work for integers above
  ##approximately 15 because modulus loses precision.
  a^n %% n == a
### Whether the integer passes the Fermat test for a randomized
### \eqn{0<a<n}
}

is.pseudoprime <- function#Check an integer for pseudo-primality to an arbitrary precision.
### A number is pseudo-prime if it is probably prime, the basis of
### which is the probabalistic Fermat test; if it passes two such
### tests, the chances are better than 3 out of 4 that \eqn{n} is
### prime.
##references<< Abelson, Hal; Jerry Sussman, and Julie
##Sussman. Structure and Interpretation of Computer
##Programs. Cambridge: MIT Press, 1984.
(n, ##<< the integer to test for pseudoprimality.
 times ##<< the number of Fermat tests to perform
){
  if(times==0)TRUE
  ##seealso<< \code{\link{fermat.test}}
  else if(fermat.test(n)) is.pseudoprime(n,times-1)
  else FALSE
### Whether the number is pseudoprime
}

.result <- list(fermat.test=list(format="",
  definition="fermat.test <- function#Test an integer for primality with Fermat's little theorem.\n### Fermat's little theorem states that if \\eqn{n} is a prime number\n### and \\eqn{a} is any positive integer less than \\eqn{n}, then\n### \\eqn{a} raised to the \\eqn{n}th power is congruent to \\eqn{a\\\n### modulo\\ n}{a modulo n}.\n##references<< \\url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}\n(n ##<< the integer to test for primality.\n ){\n  a <- floor(runif(1,min=1,max=n))\n  ##note<< \\code{fermat.test} doesn't work for integers above\n  ##approximately 15 because modulus loses precision.\n  a^n %% n == a\n### Whether the integer passes the Fermat test for a randomized\n### \\eqn{0<a<n}\n}",
  title="Test an integer for primality with Fermat's little theorem.",
  description="Fermat's little theorem states that if \\eqn{n} is a prime number\nand \\eqn{a} is any positive integer less than \\eqn{n}, then\n\\eqn{a} raised to the \\eqn{n}th power is congruent to \\eqn{a\\\nmodulo\\ n}{a modulo n}.",
  value="Whether the integer passes the Fermat test for a randomized\n\\eqn{0<a<n}",
  references="\\url{http://en.wikipedia.org/wiki/Fermat's_little_theorem}",
  `item{n}`="the integer to test for primality.",
  note="\\code{fermat.test} doesn't work for integers above\napproximately 15 because modulus loses precision."),
                is.pseudoprime=list(format="",
  definition="is.pseudoprime <- function#Check an integer for pseudo-primality to an arbitrary precision.\n### A number is pseudo-prime if it is probably prime, the basis of\n### which is the probabalistic Fermat test; if it passes two such\n### tests, the chances are better than 3 out of 4 that \\eqn{n} is\n### prime.\n##references<< Abelson, Hal; Jerry Sussman, and Julie\n##Sussman. Structure and Interpretation of Computer\n##Programs. Cambridge: MIT Press, 1984.\n(n, ##<< the integer to test for pseudoprimality.\n times ##<< the number of Fermat tests to perform\n){\n  if(times==0)TRUE\n  ##seealso<< \\code{\\link{fermat.test}}\n  else if(fermat.test(n)) is.pseudoprime(n,times-1)\n  else FALSE\n### Whether the number is pseudoprime\n}",
  title="Check an integer for pseudo-primality to an arbitrary precision.",
  description="A number is pseudo-prime if it is probably prime, the basis of\nwhich is the probabalistic Fermat test; if it passes two such\ntests, the chances are better than 3 out of 4 that \\eqn{n} is\nprime.",
  `item{times}`= "the number of Fermat tests to perform",
  value="Whether the number is pseudoprime",
  references="Abelson, Hal; Jerry Sussman, and Julie\nSussman. Structure and Interpretation of Computer\nPrograms. Cambridge: MIT Press, 1984.",
  `item{n}`="the integer to test for pseudoprimality.",
  seealso="\\code{\\link{fermat.test}}"))

### Prefix for code comments used with grep and gsub.
prefix <- "^### "

decomment <- function
### Remove comment prefix and join lines of code to form a
### documentation string.
(comments
### Character vector of prefixed comment lines.
 ){
  paste(gsub(prefix,"",comments),collapse=" ")
### String without prefixes or newlines.
}

### Necessary fields in DESCRIPTION, otherwise error.
fields <- c("Package","Maintainer","Author","Version",
            "License","Title","Description")
### Default DESCRIPTION, written if it doesn't exist.
empty.description <- matrix("",ncol=length(fields),dimnames=list(NULL,fields))

package.skeleton.dx <- function # Package skeleton deluxe
### Automates more of the setup process for a new source
### package. After inspecting the specified R code files to find
### inline documentation, it calls the standard package.skeleton
### function, which creates bare Rd files. The inline documentation is
### added to these Rd files and then these files are copied to
### ../man. It will overwrite files in the pkgdir/man directory.
(pkgdir="..",
### package directory where the DESCRIPTION file lives. Your code
### should be in pkgdir/R. We will setwd to pkgdir/R for the duration
### of the function, then switch back to where you were previously.
 code_files=NULL,
### Character vector with the names of the R code files, to be passed
### to package.skeleton, and also inspected for inline
### documentation. NULL means all files ending in .R.
 check=""
### Value indicating whether or not to check the package after
### documentation is built. Anything other than "" (the default) will
### check the package. "noex" means check the package without running
### examples, only tests (useful for debugging if your tests/examples
### take a long time).
 ){
  chdir <- file.path(pkgdir,"R")
  old.wd <- setwd(chdir)
  on.exit(setwd(old.wd))

  descfile <- file.path("..","DESCRIPTION")
  if(!file.exists(descfile)){
    write.dcf(empty.description,descfile)
    stop("Need ",descfile,"; please fill that in and try again")
  }

  ## Read description and check for errors
  desc <- read.dcf(descfile)
  for(f in fields){
    if(! f %in% colnames(desc))stop("Need ",f," in ",descfile)
    if(desc[,f]=="")stop("Need a value for ",f," in ",descfile)
  }

  ## extract docs from each file
  if(is.null(code_files))code_files <- Sys.glob("*.R")
  docs <- list()
  for(cf in code_files){
    L <- extract.docs.file(cf,check!="noex")
    for(N in names(L))docs[[N]] <- L[[N]]
  }
  for(i in names(docs)){
    docs[[i]]$author <- desc[,"Maintainer"]
    if(! 'title' %in% names(docs[[i]]))
      docs[[i]]$title <- gsub("[._]"," ",i)
  }
  name <- desc[,"Package"]
  details <- paste(paste(colnames(desc),": \\tab ",desc,"\\cr",sep=""),
                   collapse="\n")
  docs[[paste(name,"-package",sep="")]] <-
    list(title=desc[,"Title"],
         description=desc[,"Description"],
         `tabular{ll}`=details,
         author=desc[,"Maintainer"])
  ## Make package skeleton and edit Rd files
  unlink(name,rec=TRUE)
  package.skeleton(name,code_files=code_files)
  cat("Modifying files automatically generated by package.skeleton:\n")
  for(N in names(docs))modify.Rd.file(N,name,docs)
  file.copy(file.path(name,'man'),"..",rec=TRUE)
  unlink(name,rec=TRUE)

  if(check!=""){
    Rdir <- setwd(file.path("..",".."))
    cdir <- basename(dirname(Rdir))
    system(paste("R CMD check",cdir))
  }
  ## rebuild examples if we didn't test them:
  if(check=="noex")package.skeleton.dx(pkgdir,code_files,"")
}

modify.Rd.file <- function
### Add inline documentation from comments to an Rd file
### automatically-generated by package.skeleton.
(N,
### Name of function/file to which we will add documentation.
 pkg,
### Package name.
 docs
### Named list of documentation in extracted comments.
 ){
  fb <- paste(N,".Rd",sep="")
  f <- file.path(pkg,'man',fb)
  ## If there are no significant docs in the comments then the object
  ## should still be documented, by writing the file by hand in the
  ## man directory. This will write a blank Rd file if none exists, so
  ## it's easy to get started.
  if((length(docs[[N]])<3) &&
     file.exists(file.path("..","man",fb))){
    unlink(f)
    return()
  }
  cat(N,":",sep="")
  d <- docs[[N]]
  dlines <- readLines(f)

  ## cut out alias line if we are in the package file and there is a
  ## matching function
  if(length(grep("-package$",N)))
    dlines <- dlines[-grep(paste("alias[{]",N,sep=""),dlines)-1]

  ## cut out all comments {} interferes with regex matching
  dlines <- dlines[-grep("^[%~]",dlines)]

  ## cut out a couple of sections that cause warnings
  o <- grep("Optionally",dlines)
  if(length(o))dlines <- dlines[-(o:(o+1))]
  ## delete examples til the end of the file (also includes keywords)
  dlines <- dlines[1:(tail(grep("examples[{]$",dlines),1)-1)]
  ## add back a minimal examples section to find and replace
  dlines <- c(dlines,"\\examples{}")

  ## Find and replace based on data in d
  txt <- paste(dlines,collapse="\n")
  for(torep in names(d)){
    cat(" ",torep,sep="")
    FIND1 <- gsub("\\\\","\\\\\\\\",torep)
    FIND <- paste(gsub("([{}])","\\\\\\1",FIND1),"[{][^}]*[}]",sep="")
    ## need to escape backslashes for faithful copying of the comments
    ## to the Rd file:
    REP <- paste(FIND1,"{",gsub("\\\\","\\\\\\\\",d[[torep]]),"}",sep="")
    ## escape percent signs in R code:
    REP <- gsub("%","\\\\\\\\%",REP)
    txt <- gsub(FIND,REP,txt)
  }

  ## Fix usage
  m <- regexpr("usage[{][^}]*[}]",txt)
  Mend <- m+attr(m,"match.length")
  utxt <- substr(txt,m,Mend)
  if(length(grep("usage[{]data",utxt)))
     utxt <- gsub("data[(]([^)]*)[)]","\\1",utxt)
  ## add another backslash due to bug in package.skeleton
  txt <- paste(substr(txt,1,m-1),
               gsub("\\\\","\\\\\\\\",utxt),
               substr(txt,Mend+1,nchar(txt)),
               sep="")
  ## This doesn't work if there are quotes in the default values:
  ## gsub(",",paste("\n",paste(rep(" ",l=nchar(N)-1),collapse="")),utxt)
  cat(txt,file=f)
  cat("\n")
}

extract.docs.file <- function # Extract documentation from a file
### Parse an R code file and extract inline documentation from
### comments around each function.
(code.file,
### The R code file to parse.
 write.examples=TRUE
### Gather examples from test files?
 ){
  code <- readLines(code.file)
  comment.lines <- grep(prefix,code)
  e <- new.env()
  old <- options(keep.source.pkgs=TRUE)
  r <- try(sys.source(code.file,e),TRUE)
  if(class(r)=="try-error")
    stop("source ",code.file," failed with error:\n",r)
  options(old)
  objs <- sapply(ls(e),get,e,simplify=FALSE)
  extract.docs <- function(on){
    res <- try({
      o <- objs[[on]]
      doc <- if("function"%in%class(o)){
        tdoc <- extract.docs.fun(o)
        if(write.examples){ ## do not get examples from test files.
          tfile <- file.path("..","tests",paste(on,".R",sep=""))
          if(file.exists(tfile))
            tdoc[["examples"]] <- paste(readLines(tfile),collapse="\n")
        }
        tdoc
      }else list()
      ## Take the line before the first occurence of the variable
      defined.on <- grep(paste("^",on,sep=""),code)[1]-1
      if(!"description"%in%names(doc) && defined.on%in%comment.lines){
        comments.before <- comment.lines[comment.lines<=defined.on]
        these.comment.lines <- if(length(comments.before)==1)comments.before else{
          diffs <- diff(comments.before)
          comments.before[max(which(diffs>1))+1]:defined.on
        }
        doc$description <- decomment(code[these.comment.lines])
      }
      doc
    },FALSE)
    if(class(res)=="try-error"){
      cat("Failed to extract docs for: ",on,"\n\n")
      list()
    }
    else res
  }
  res <- sapply(names(objs),extract.docs,simplify=FALSE)
  res
### named list of lists. Each element is the result of a call to
### extract.docs.fun, with names corresponding to functions found in
### the R code file.
}

extract.docs.fun <- function # Extract documentation from a function
### Given a function, return a list describing inline documentation in
### the source of that function (relies on source attr).
(fun
### The function to examine.
 ){
  res <- list()
  code <- attr(fun,"source")
  clines <- grep("^#",code)
  if(length(grep("#",code[1])))res$title <- gsub("[^#]*#(.*)","\\1",code[1])
  if(length(clines)==0)return(res) ## no comments found
  bounds <- which(diff(clines)!=1)
  starts <- c(1,bounds+1)
  ends <- c(bounds,length(clines))
  for(i in seq_along(starts)){
    start <- clines[starts[i]]
    end <- clines[ends[i]]
    lab <- if(end+1==length(code))"value"
    else if(start==2)"description"
    else {
      arg <- gsub("^[ (]*","",code[start-1])
      arg <- gsub("^([^=,]*)[=,].*","\\1",arg)
      arg <- gsub("...","\\dots",arg,fix=TRUE) ##special case for dots
      paste("item{",arg,"}",sep="")
    }
    res[[lab]] <- decomment(code[start:end])
  }
  ##details<<
  ## For simple functions/arguments, the argument may also be documented by
  ## appending ##<< comments on the same line as the argument. For those who
  ## wish to become confused, any following ### comment lines will be appended.
  arg.pat <- "^\\s*\\(?\\s*([\\w\\.]+).*##<<\\s*(\\S.*?)\\s*$"
  for ( k in 2:length(code) ){
    if ( 0 < length(grep(arg.pat,code[k],perl=TRUE)) ){
      arg <- gsub(arg.pat,"\\\\item\\{\\1\\}",code[k],perl=TRUE)
      comment <- gsub(arg.pat,"\\2",code[k],perl=TRUE);
      res[[arg]] <-
        if ( is.null(res[[arg]]) )comment
        else paste(comment,res[[arg]],sep=" ")
    }
  }

  skeleton.fields <- c("alias","details","keyword","references","author",
                       "note","seealso","value")
  ##details<<
  ## Additionally, contiguous sections of ## comment lines beginning with
  ## xxx<< (where xxx is one of the "other" fields: alias, details, keyword,
  ## references, author, note, seealso or value) are accumulated and inserted in
  ## the relevant part of the .Rd file.
  ##
  ## In the case of value, the extra information is appended to that from
  ## any final ### comment lines.

  ## but this should not appear, because separated by a blank line
  extra.regexp <- paste("^\\s*##<<(",paste(skeleton.fields,collapse="|"),
                        ")\\s*(.*)$",sep="")
  starts.extra <- grep(extra.regexp,code,perl=TRUE)
  cont.re <- "^\\s*##\\s*";
  for ( start in starts.extra ){
    line <- code[start]
    field <- gsub(extra.regexp,"\\1",line,perl=TRUE)
    payload <- gsub(extra.regexp,"\\2",line,perl=TRUE)
    if ( start < length(code) ){
      for ( k in (start+1):length(code) ){
        if ( k %in% starts.extra        # go on to next extra section
            || 0 == length(grep(cont.re,code[k])) ){ # blank line or code ends
          if ( "alias" == field ){
            ##note<< Alias extras are automatically split at new lines.
            payload <- gsub("\\n+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          } else if ("keyword" == field ){
            ##keyword<< documentation utilities
            ##note<< Keyword extras are auto-split at white space.
            payload <- gsub("\\s+",paste("\\}\n\\",field,"\\{",sep=""),
                            payload,perl=TRUE)
          }
          ##details<< Each separate extra section appears as a new paragraph
          ## except that empty sections (no matter how many lines) are ignored.
          if ( 0 == length(grep("^\\s*$",payload,perl=TRUE)) )
            res[[field]] <-
              if ( is.null(res[[field]]) )payload
              else res[[field]] <- paste(res[[field]], payload, sep="\n\n")
          break;
        } else {
          payload <- paste(payload,sub(cont.re,"",code[k],perl=TRUE),sep="\n")
        }
      }
    }
  }
  res
### Named list of character strings extracted from comments. For each
### name N we will look for N\{...\} in the Rd file and replace it
### with the string in this list (implemented in modify.Rd.file).
}

.result <- 
 list(decomment = list(format="",title="decomment",definition = "decomment <- function\n### Remove comment prefix and join lines of code to form a\n### documentation string.\n(comments\n### Character vector of prefixed comment lines.\n ){\n  paste(gsub(prefix,\"\",comments),collapse=\" \")\n### String without prefixes or newlines.\n}",  
     description = "Remove comment prefix and join lines of code to form a\ndocumentation string.",  
     `item{comments}` = "Character vector of prefixed comment lines.",  
     value = "String without prefixes or newlines."),
      empty.description = list(format="",title="empty description",
     definition = "empty.description <- matrix(\"\",ncol=length(fields),dimnames=list(NULL,fields))",  
     description = "Default DESCRIPTION, written if it doesn't exist."),  
     extract.docs.file = list(definition = "extract.docs.file <- function # Extract documentation from a file\n### Parse an R code file and extract inline documentation from\n### comments around each function.\n(code.file,\n### The R code file to parse.\n write.examples=TRUE\n### Gather examples from test files?\n ){\n  code <- readLines(code.file)\n  comment.lines <- grep(prefix,code)\n  e <- new.env()\n  old <- options(keep.source.pkgs=TRUE)\n  r <- try(sys.source(code.file,e),TRUE)\n  if(class(r)==\"try-error\")\n    stop(\"source \",code.file,\" failed with error:\\n\",r)\n  options(old)\n  objs <- sapply(ls(e),get,e,simplify=FALSE)\n  extract.docs <- function(on){\n    res <- try({\n      o <- objs[[on]]\n      doc <- if(\"function\"%in%class(o)){\n        tdoc <- extract.docs.fun(o)\n        if(write.examples){ ## do not get examples from test files.\n          tfile <- file.path(\"..\",\"tests\",paste(on,\".R\",sep=\"\"))\n          if(file.exists(tfile))\n            tdoc[[\"examples\"]] <- paste(readLines(tfile),collapse=\"\\n\")\n        }\n        tdoc\n      }else list()\n      ## Take the line before the first occurence of the variable\n      defined.on <- grep(paste(\"^\",on,sep=\"\"),code)[1]-1\n      if(!\"description\"%in%names(doc) && defined.on%in%comment.lines){\n        comments.before <- comment.lines[comment.lines<=defined.on]\n        these.comment.lines <- if(length(comments.before)==1)comments.before else{\n          diffs <- diff(comments.before)\n          comments.before[max(which(diffs>1))+1]:defined.on\n        }\n        doc$description <- decomment(code[these.comment.lines])\n      }\n      doc\n    },FALSE)\n    if(class(res)==\"try-error\"){\n      cat(\"Failed to extract docs for: \",on,\"\\n\\n\")\n      list()\n    }\n    else res\n  }\n  res <- sapply(names(objs),extract.docs,simplify=FALSE)\n  res\n### named list of lists. Each element is the result of a call to\n### extract.docs.fun, with names corresponding to functions found in\n### the R code file.\n}",  
         title = "Extract documentation from a file",
       format="",
       description = "Parse an R code file and extract inline documentation from\ncomments around each function.",  
         `item{code.file}` = "The R code file to parse.", `item{write.examples}` = "Gather examples from test files?",  
         value = "named list of lists. Each element is the result of a call to\nextract.docs.fun, with names corresponding to functions found in\nthe R code file."),  
     extract.docs.fun = list(format="",
       definition = "extract.docs.fun <- function # Extract documentation from a function\n### Given a function, return a list describing inline documentation in\n### the source of that function (relies on source attr).\n(fun\n### The function to examine.\n ){\n  res <- list()\n  code <- attr(fun,\"source\")\n  clines <- grep(\"^#\",code)\n  if(length(grep(\"#\",code[1])))res$title <- gsub(\"[^#]*#(.*)\",\"\\\\1\",code[1])\n  if(length(clines)==0)return(res) ## no comments found\n  bounds <- which(diff(clines)!=1)\n  starts <- c(1,bounds+1)\n  ends <- c(bounds,length(clines))\n  for(i in seq_along(starts)){\n    start <- clines[starts[i]]\n    end <- clines[ends[i]]\n    lab <- if(end+1==length(code))\"value\"\n    else if(start==2)\"description\"\n    else {\n      arg <- gsub(\"^[ (]*\",\"\",code[start-1])\n      arg <- gsub(\"^([^=,]*)[=,].*\",\"\\\\1\",arg)\n      arg <- gsub(\"...\",\"\\\\dots\",arg,fix=TRUE) ##special case for dots\n      paste(\"item{\",arg,\"}\",sep=\"\")\n    }\n    res[[lab]] <- decomment(code[start:end])\n  }\n  ##details<<\n  ## For simple functions/arguments, the argument may also be documented by\n  ## appending ##<< comments on the same line as the argument. For those who\n  ## wish to become confused, any following ### comment lines will be appended.\n  arg.pat <- \"^\\\\s*\\\\(?\\\\s*([\\\\w\\\\.]+).*##<<\\\\s*(\\\\S.*?)\\\\s*$\"\n  for ( k in 2:length(code) ){\n    if ( 0 < length(grep(arg.pat,code[k],perl=TRUE)) ){\n      arg <- gsub(arg.pat,\"\\\\\\\\item\\\\{\\\\1\\\\}\",code[k],perl=TRUE)\n      comment <- gsub(arg.pat,\"\\\\2\",code[k],perl=TRUE);\n      res[[arg]] <-\n        if ( is.null(res[[arg]]) )comment\n        else paste(comment,res[[arg]],sep=\" \")\n    }\n  }\n\n  skeleton.fields <- c(\"alias\",\"details\",\"keyword\",\"references\",\"author\",\n                       \"note\",\"seealso\",\"value\")\n  ##details<<\n  ## Additionally, contiguous sections of ## comment lines beginning with\n  ## xxx<< (where xxx is one of the \"other\" fields: alias, details, keyword,\n  ## references, author, note, seealso or value) are accumulated and inserted in\n  ## the relevant part of the .Rd file.\n  ##\n  ## In the case of value, the extra information is appended to that from\n  ## any final ### comment lines.\n\n  ## but this should not appear, because separated by a blank line\n  extra.regexp <- paste(\"^\\\\s*##<<(\",paste(skeleton.fields,collapse=\"|\"),\n                        \")\\\\s*(.*)$\",sep=\"\")\n  starts.extra <- grep(extra.regexp,code,perl=TRUE)\n  cont.re <- \"^\\\\s*##\\\\s*\";\n  for ( start in starts.extra ){\n    line <- code[start]\n    field <- gsub(extra.regexp,\"\\\\1\",line,perl=TRUE)\n    payload <- gsub(extra.regexp,\"\\\\2\",line,perl=TRUE)\n    if ( start < length(code) ){\n      for ( k in (start+1):length(code) ){\n        if ( k %in% starts.extra        # go on to next extra section\n            || 0 == length(grep(cont.re,code[k])) ){ # blank line or code ends\n          if ( \"alias\" == field ){\n            ##note<< Alias extras are automatically split at new lines.\n            payload <- gsub(\"\\\\n+\",paste(\"\\\\}\\n\\\\\",field,\"\\\\{\",sep=\"\"),\n                            payload,perl=TRUE)\n          } else if (\"keyword\" == field ){\n            ##keyword<< documentation utilities\n            ##note<< Keyword extras are auto-split at white space.\n            payload <- gsub(\"\\\\s+\",paste(\"\\\\}\\n\\\\\",field,\"\\\\{\",sep=\"\"),\n                            payload,perl=TRUE)\n          }\n          ##details<< Each separate extra section appears as a new paragraph\n          ## except that empty sections (no matter how many lines) are ignored.\n          if ( 0 == length(grep(\"^\\\\s*$\",payload,perl=TRUE)) )\n            res[[field]] <-\n              if ( is.null(res[[field]]) )payload\n              else res[[field]] <- paste(res[[field]], payload, sep=\"\\n\\n\")\n          break;\n        } else {\n          payload <- paste(payload,sub(cont.re,\"\",code[k],perl=TRUE),sep=\"\\n\")\n        }\n      }\n    }\n  }\n  res\n### Named list of character strings extracted from comments. For each\n### name N we will look for N\\{...\\} in the Rd file and replace it\n### with the string in this list (implemented in modify.Rd.file).\n}",  
         title = "Extract documentation from a function", description = "Given a function, return a list describing inline documentation in\nthe source of that function (relies on source attr).",  
         `item{fun}` = "The function to examine.", value = "Named list of character strings extracted from comments. For each\nname N we will look for N\\{...\\} in the Rd file and replace it\nwith the string in this list (implemented in modify.Rd.file).",  
         details = "For simple functions/arguments, the argument may also be documented by\nappending ##<< comments on the same line as the argument. For those who\nwish to become confused, any following ### comment lines will be appended.\n\nAdditionally, contiguous sections of ## comment lines beginning with\nxxx<< (where xxx is one of the \"other\" fields: alias, details, keyword,\nreferences, author, note, seealso or value) are accumulated and inserted in\nthe relevant part of the .Rd file.\n\nIn the case of value, the extra information is appended to that from\nany final ### comment lines.\n\nEach separate extra section appears as a new paragraph\nexcept that empty sections (no matter how many lines) are ignored.",  
         note = "Alias extras are automatically split at new lines.\n\nKeyword extras are auto-split at white space.",  
         keyword = "documentation}\n\\keyword{utilities"),
      fields = list(format="",title="fields",
         definition = "fields <- c(\"Package\",\"Maintainer\",\"Author\",\"Version\",\n            \"License\",\"Title\",\"Description\")",  
         description = "Necessary fields in DESCRIPTION, otherwise error."),  
     modify.Rd.file = list(definition = "modify.Rd.file <- function\n### Add inline documentation from comments to an Rd file\n### automatically-generated by package.skeleton.\n(N,\n### Name of function/file to which we will add documentation.\n pkg,\n### Package name.\n docs\n### Named list of documentation in extracted comments.\n ){\n  fb <- paste(N,\".Rd\",sep=\"\")\n  f <- file.path(pkg,'man',fb)\n  ## If there are no significant docs in the comments then the object\n  ## should still be documented, by writing the file by hand in the\n  ## man directory. This will write a blank Rd file if none exists, so\n  ## it's easy to get started.\n  if((length(docs[[N]])<3) &&\n     file.exists(file.path(\"..\",\"man\",fb))){\n    unlink(f)\n    return()\n  }\n  cat(N,\":\",sep=\"\")\n  d <- docs[[N]]\n  dlines <- readLines(f)\n\n  ## cut out alias line if we are in the package file and there is a\n  ## matching function\n  if(length(grep(\"-package$\",N)))\n    dlines <- dlines[-grep(paste(\"alias[{]\",N,sep=\"\"),dlines)-1]\n\n  ## cut out all comments {} interferes with regex matching\n  dlines <- dlines[-grep(\"^[%~]\",dlines)]\n\n  ## cut out a couple of sections that cause warnings\n  o <- grep(\"Optionally\",dlines)\n  if(length(o))dlines <- dlines[-(o:(o+1))]\n  ## delete examples til the end of the file (also includes keywords)\n  dlines <- dlines[1:(tail(grep(\"examples[{]$\",dlines),1)-1)]\n  ## add back a minimal examples section to find and replace\n  dlines <- c(dlines,\"\\\\examples{}\")\n\n  ## Find and replace based on data in d\n  txt <- paste(dlines,collapse=\"\\n\")\n  for(torep in names(d)){\n    cat(\" \",torep,sep=\"\")\n    FIND1 <- gsub(\"\\\\\\\\\",\"\\\\\\\\\\\\\\\\\",torep)\n    FIND <- paste(gsub(\"([{}])\",\"\\\\\\\\\\\\1\",FIND1),\"[{][^}]*[}]\",sep=\"\")\n    ## need to escape backslashes for faithful copying of the comments\n    ## to the Rd file:\n    REP <- paste(FIND1,\"{\",gsub(\"\\\\\\\\\",\"\\\\\\\\\\\\\\\\\",d[[torep]]),\"}\",sep=\"\")\n    ## escape percent signs in R code:\n    REP <- gsub(\"%\",\"\\\\\\\\\\\\\\\\%\",REP)\n    txt <- gsub(FIND,REP,txt)\n  }\n\n  ## Fix usage\n  m <- regexpr(\"usage[{][^}]*[}]\",txt)\n  Mend <- m+attr(m,\"match.length\")\n  utxt <- substr(txt,m,Mend)\n  if(length(grep(\"usage[{]data\",utxt)))\n     utxt <- gsub(\"data[(]([^)]*)[)]\",\"\\\\1\",utxt)\n  ## add another backslash due to bug in package.skeleton\n  txt <- paste(substr(txt,1,m-1),\n               gsub(\"\\\\\\\\\",\"\\\\\\\\\\\\\\\\\",utxt),\n               substr(txt,Mend+1,nchar(txt)),\n               sep=\"\")\n  ## This doesn't work if there are quotes in the default values:\n  ## gsub(\",\",paste(\"\\n\",paste(rep(\" \",l=nchar(N)-1),collapse=\"\")),utxt)\n  cat(txt,file=f)\n  cat(\"\\n\")\n}",  
         description = "Add inline documentation from comments to an Rd file\nautomatically-generated by package.skeleton.",
       format="",title="modify Rd file",
         `item{N}` = "Name of function/file to which we will add documentation.",  
         `item{pkg}` = "Package name.", `item{docs}` = "Named list of documentation in extracted comments."),  
     package.skeleton.dx = list(format="",
       definition = "package.skeleton.dx <- function # Package skeleton deluxe\n### Automates more of the setup process for a new source\n### package. After inspecting the specified R code files to find\n### inline documentation, it calls the standard package.skeleton\n### function, which creates bare Rd files. The inline documentation is\n### added to these Rd files and then these files are copied to\n### ../man. It will overwrite files in the pkgdir/man directory.\n(pkgdir=\"..\",\n### package directory where the DESCRIPTION file lives. Your code\n### should be in pkgdir/R. We will setwd to pkgdir/R for the duration\n### of the function, then switch back to where you were previously.\n code_files=NULL,\n### Character vector with the names of the R code files, to be passed\n### to package.skeleton, and also inspected for inline\n### documentation. NULL means all files ending in .R.\n check=\"\"\n### Value indicating whether or not to check the package after\n### documentation is built. Anything other than \"\" (the default) will\n### check the package. \"noex\" means check the package without running\n### examples, only tests (useful for debugging if your tests/examples\n### take a long time).\n ){\n  chdir <- file.path(pkgdir,\"R\")\n  old.wd <- setwd(chdir)\n  on.exit(setwd(old.wd))\n\n  descfile <- file.path(\"..\",\"DESCRIPTION\")\n  if(!file.exists(descfile)){\n    write.dcf(empty.description,descfile)\n    stop(\"Need \",descfile,\"; please fill that in and try again\")\n  }\n\n  ## Read description and check for errors\n  desc <- read.dcf(descfile)\n  for(f in fields){\n    if(! f %in% colnames(desc))stop(\"Need \",f,\" in \",descfile)\n    if(desc[,f]==\"\")stop(\"Need a value for \",f,\" in \",descfile)\n  }\n\n  ## extract docs from each file\n  if(is.null(code_files))code_files <- Sys.glob(\"*.R\")\n  docs <- list()\n  for(cf in code_files){\n    L <- extract.docs.file(cf,check!=\"noex\")\n    for(N in names(L))docs[[N]] <- L[[N]]\n  }\n  for(i in names(docs)){\n    docs[[i]]$author <- desc[,\"Maintainer\"]\n    if(! 'title' %in% names(docs[[i]]))\n      docs[[i]]$title <- gsub(\"[._]\",\" \",i)\n  }\n  name <- desc[,\"Package\"]\n  details <- paste(paste(colnames(desc),\": \\\\tab \",desc,\"\\\\cr\",sep=\"\"),\n                   collapse=\"\\n\")\n  docs[[paste(name,\"-package\",sep=\"\")]] <-\n    list(title=desc[,\"Title\"],\n         description=desc[,\"Description\"],\n         `tabular{ll}`=details,\n         author=desc[,\"Maintainer\"])\n  ## Make package skeleton and edit Rd files\n  unlink(name,rec=TRUE)\n  package.skeleton(name,code_files=code_files)\n  cat(\"Modifying files automatically generated by package.skeleton:\\n\")\n  for(N in names(docs))modify.Rd.file(N,name,docs)\n  file.copy(file.path(name,'man'),\"..\",rec=TRUE)\n  unlink(name,rec=TRUE)\n\n  if(check!=\"\"){\n    Rdir <- setwd(file.path(\"..\",\"..\"))\n    cdir <- basename(dirname(Rdir))\n    system(paste(\"R CMD check\",cdir))\n  }\n  ## rebuild examples if we didn't test them:\n  if(check==\"noex\")package.skeleton.dx(pkgdir,code_files,\"\")\n}",  
         title = "Package skeleton deluxe", description = "Automates more of the setup process for a new source\npackage. After inspecting the specified R code files to find\ninline documentation, it calls the standard package.skeleton\nfunction, which creates bare Rd files. The inline documentation is\nadded to these Rd files and then these files are copied to\n../man. It will overwrite files in the pkgdir/man directory.",  
         `item{pkgdir}` = "package directory where the DESCRIPTION file lives. Your code\nshould be in pkgdir/R. We will setwd to pkgdir/R for the duration\nof the function, then switch back to where you were previously.",  
         `item{code_files}` = "Character vector with the names of the R code files, to be passed\nto package.skeleton, and also inspected for inline\ndocumentation. NULL means all files ending in .R.",  
         `item{check}` = "Value indicating whether or not to check the package after\ndocumentation is built. Anything other than \"\" (the default) will\ncheck the package. \"noex\" means check the package without running\nexamples, only tests (useful for debugging if your tests/examples\ntake a long time)."),  
     prefix = list(definition = "prefix <- \"^### \"", description = "Prefix for code comments used with grep and gsub.",
       format="",title="prefix"))
 

CalculateSampleCovariance <- function(x, y, verbose = TRUE) {
  # Computes the sample covariance between two vectors.
  #
  # Args:
  #   x: One of two vectors whose sample covariance is to be calculated.
  #   y: The other vector. x and y must have the same length, greater than one,
  #      with no missing values.
  #   verbose: If TRUE, prints sample covariance; if not, not. Default is TRUE.
  #
  # Returns:
  #   The sample covariance between x and y.
  n <- length(x)
  # Error handling
  if (n <= 1 || n != length(y)) {
    stop("Arguments x and y have invalid lengths: ",
         length(x), " and ", length(y), ".")
  }
  if (TRUE %in% is.na(x) || TRUE %in% is.na(y)) {
    stop(" Arguments x and y must not have missing values.")
  }
  covariance <- var(x, y)
  if (verbose)
    cat("Covariance = ", round(covariance, 4), ".\n", sep = "")
  return(covariance)
}

google <- function(src,...){
  # Extract docs from google header comments.
  #
  # Args:
  # src: lines of code of the function source.
  #
  # Returns:
  # An inner Documentation List.
  i <- 2
  docs <- list()
  mode <- "description"
  comment.pattern <- "\\W*#\\W*"
  while(grepl(comment.pattern,line <- src[i])){
    content <- gsub(comment.pattern,"",line)
    if(grepl("Returns:",line)){
      mode <- "value"
    }else if(mode=="value"){
      docs$value <- c(docs$value,content)
    }
    if(grepl("Args:",line)){
      mode <- "args"
    }else if(mode=="args"){
      prefix <- gsub(":.*","",content)
      if(grepl(":",content))lname <- sprintf("item{%s}",prefix)
      suffix <- gsub(".*:\\s*","",content)
      docs[[lname]] <- c(docs[[lname]],suffix)
    }
    if(mode=="description"){
      docs$description <- c(docs$description,content)
    }
    i <- i+1
  }
  lapply(docs,function(x)gsub("\\s*$","",paste(x,collapse="\n")))
}
.parsers <- list(google=forfun(google))

#src <- getSource(CalculateSampleCovariance)
#google(src)
.dontcheck <- TRUE

.result <-
  list(google=list(description="Extract docs from google header comments.",
         `item{src}`="lines of code of the function source.",
         value="An inner Documentation List."),
       CalculateSampleCovariance=list(
         description="Computes the sample covariance between two vectors.",
         `item{x}`="One of two vectors whose sample covariance is to be calculated.",
         `item{y}`="The other vector. x and y must have the same length, greater than one,\nwith no missing values.",
         `item{verbose}`="If TRUE, prints sample covariance; if not, not. Default is TRUE.",
         value="The sample covariance between x and y."))

spaced <- function
### desc
(arg1,
 arg2
 ){
  x <- arg1
  x*2
### some result

}
.result <- 
 list(spaced = list(definition = "spaced <- function\n### desc\n(arg1,\n arg2\n ){\n  x <- arg1\n  x*2\n### some result\n\n}",
     format = "", title = "spaced",value="some result",description="desc"))

foo <- function
### This description
###
### should make it into the docs.
(x){
}

.result <-
  list(foo=list(description="This description\n\nshould make it into the docs.",
       definition="foo <- function\n### This description\n###\n### should make it into the docs.\n(x){\n}",
       format="",
       title="foo"))

read.fasta <- function
### Read sequences in FASTA format into a named character vector
(infile
### Name of the sequence file
 ){
  tmp <- sapply(strsplit(strsplit(paste('\n\n\n',paste(readLines(infile),collapse='\n'),sep=''),split='\n>')[[1]],'\n'),function(v)c(v[1],paste(v[2:length(v)],collapse='')))
  seqs <- tmp[2,]
  names(seqs) <- tmp[1,]
  blank <- names(seqs)==''
  names(seqs)[blank] <- seqs[blank]
  names(seqs) <- gsub(' ','',names(seqs))
  seqs[seqs!='']
}
##debug(read.fasta)

### Letters in the DNA alphabet, used to auto-detect sequence type
dna.letters <- c("*","A","T","G","C")
### DNA identity substitution matrix.
dna.identity <- matrix(0,nrow=length(dna.letters),ncol=length(dna.letters),
                       dimnames=list(dna.letters,dna.letters))
diag(dna.identity) <- 1
dna.identity['*','*'] <- 0
seqs.to.mat <- function
### Calculate pairwise differences between sequences using a
### substitution matrix.
(seq.vec,
### DNA or protein sequences.
 subs.mat=NULL){
### Substitution matrix with dimnames that match the letters used in
### the sequence data, or a character vector that specifies a common
### substitution matrix (as defined in the Biostrings package). NULL
### specifies that we will guess a suitable substitution matrix to
### match your input sequences (DNA=>identity, protein=>BLOSUM62).
  if(is.null(names(seq.vec)))names(seq.vec) <- seq.vec
  chars <- sapply(seq.vec,nchar)
  seqsum <- table(chars)
  if(length(seqsum)>1){
    print(as.data.frame(seqsum))
    i <- which.max(seqsum)
    cat("Sequences not of length ",names(seqsum)[i],":\n",sep="")
    rows <- as.integer(names(seqsum)[i])!=chars
    print(data.frame(chars,name=names(seq.vec),row.names=NULL)[rows,])
    stop("All input sequences must be of the same length.")
  }
  d <- toupper(gsub('[- .]',"*",seq.vec[unique(names(seq.vec))]))
  print(d)
  letters <- unique(c(unlist(strsplit(d,split='')),dna.letters))
  ##if dna alignment use simple identity matrix
  looks.like.dna <- identical(sort(letters),sort(dna.letters))
  if(is.null(subs.mat))
    subs.mat <- if(looks.like.dna)dna.identity else "BLOSUM62"
  if(mode(subs.mat)=="character"){
    ex <- substitute(data(M,package="Biostrings"),list(M=subs.mat))
    eval(ex)
    subs.mat <- get(subs.mat)
  }
  print(subs.mat)
  N <- length(d)
  m <- matrix(0,nrow=N,ncol=N,dimnames=list(names(d),names(d)))
  for(i in 1:N)for(j in 1:i){
    seqs <- sapply(strsplit(c(d[i],d[j]),split=''),c)
    entry <- try(apply(seqs,1,function(x)subs.mat[x[1],x[2]]))
    if(class(entry)=="try-error"){
      print(seqs)
      stop("Sequence difference matrix construction failed.")
    }
    ## subscript out of bounds here usually means bad matrix
    m[i,j] <- m[j,i] <- -sum(entry)
  }
  m <- m-min(m)
  attr(m,'seqs') <- d
  print(m[1:min(5,nrow(m)),1:min(5,ncol(m))])
  m
### The matrix of distances between each input sequence, with dimnames
### corresponding to either the sequences, or the sequence names (if
### they exist)
}
##debug(seqs.to.mat)

make.logo.ps <- function
### Create a logo using weblogo, then read it in using grImport
(helices,
### Sequences to plot in the logo
 psbase
### Base filename for the logo postscript and xml files, should be the
### full path name except for the trailing .ps
 ){
  psfile <- paste(psbase,'ps',sep='.')
  xmlfile <- paste(psfile,'xml',sep='.')
  seq.text <- paste(paste('>',helices,'\n',helices,sep=''),collapse='\n')
  write(seq.text,psbase)
  execdir <- system.file("exec",package="sublogo")
  cmd <- paste("PATH=",execdir,
               ":$PATH seqlogo -c -F EPS -f ",psbase,
               "|sed 's/^EndLine/%EndLine/'|sed 's/^EndLogo/%EndLogo/' >",
               psfile,sep="")
  cat(cmd,'\n')
  system(cmd)
  owd <- setwd(tempdir())
  PostScriptTrace(psfile,xmlfile)
  setwd(owd)
  pic <- readPicture(xmlfile)
  pic
### Grid picture grob as read using readPicture
}
##debug(make.logo.ps)

sublogo.dendrogram <- function
### Main function for drawing sublogo dendrograms.
(M,
### difference matrix as constructed by seqs.to.mat (although in
### principle any object with a valid as.dist method could be used)
 main='',
### plot title
 subtit=NULL,
### plot subtitle
 base=tempfile(),
### base file name for temporary logo files
 cutline=150,
### Distance for cutting the tree. Draw a sublogo for each
### leaf. Normally you will plot once, then inspect the dendrogram to
### determine which is a good value for cutline, then plot again using
### your chosen cutline.
 dend.width=30,
### Percent of the plot to be occupied by the dendrogram. The logos
### will be displayed with equal widths on either side.
 cex=1
### character expansion factor for the dendrogram
 ){
  hc <- hclust(as.dist(M),method="average")
  dend <- as.dendrogram(hc)
  fam <- cutree(hc,h=cutline)[labels(dend)] # order by plotting method
  famids <- unique(fam)
  famtab <- data.frame(fam,y=1:length(fam))
  famtab$seq <- attr(M,'seqs')[rownames(famtab)]
  fam.nontriv <- sapply(famids,function(i)sum(famtab$fam==i))>1
  names(fam.nontriv) <- famids
  if(is.null(subtit))
    subtit <- paste(nrow(M),"sequences,",sum(fam.nontriv),"families")
  xrange <- c(0,1)
  yrange <- c(0,max(famtab[,'y'])+1)
  draw.box <- function(i){ # replace with logos
    subtab <- famtab[famtab[,'fam']==i,]
    grprange <- range(subtab[,'y'])
    rect(xrange[1],grprange[1]-0.25,xrange[2],grprange[2]+0.25)
  }
  draw.logo <- function(i){
    ## do not draw sublogo for a family of trivial size
    if(fam.nontriv[as.character(i)]){ 
      subtab <- famtab[famtab[,'fam']==i,]
      grprange <- range(subtab[,'y'])
      tmpfile <- paste(base,i,sep='.')
      logo <- make.logo.ps(subtab$seq,tmpfile)
      grid.picture(logo,
                   x=xrange[1],
                   y=unit(grprange[1]+0.25,'native'),
                   height=unit(diff(grprange)-0.5,'native'),
                   distort=TRUE,
                   just=c(0,0),
                   fillText=TRUE)
    }
  }

  bottomspace <- 0.6
  topspace <- 0.4
  side.percents <- (100-dend.width)/2
  layout(matrix(1:3,ncol=3),c(side.percents,dend.width,side.percents))
  par(mai=c(bottomspace,0,topspace,0),cex=1)
  
  ## Big summary logo on left
  plot(xrange,yrange,
       bty='n',xaxt='n',yaxt='n',ylab='',xlab='',type='n',yaxs='i')
  biglogo <- make.logo.ps(famtab$seq,paste(base,'0',sep='.'))
  vps <- baseViewports()
  pushViewport(vps$inner,vps$figure,vps$plot)
  grid.picture(biglogo,
               y=unit(0,'native'),
               height=unit(length(fam),'native'),
               just=c(0.5,0),
               exp=0,
               distort=TRUE,
               fillText=TRUE)
  popViewport(3)
  
  ## Dendrogram in middle
  par(mai=c(bottomspace,0,topspace,
        max(strwidth(colnames(M),'inches',
                     cex))/6*5),
      family='mono')
  par(xpd=NA)
  plot(dend,h=TRUE,edgePar=list(lwd=2),nodePar=list(lab.cex=cex,pch=""))
  par(family="")
  segments(cutline,1,cutline,length(fam))
  ##axis(3,cutline,lty=0,line=0)
  
  ## Title in the middle
  title(main,line=0.5)
  mtext(subtit,line=-0.7,cex=1)

  # Sublogos on the right side
  par(mai=c(bottomspace,0,topspace,0))
  plot(xrange,yrange,
       bty='n',xaxt='n',yaxt='n',ylab='',xlab='',type='n',yaxs='i')
  vps <- baseViewports()
  pushViewport(vps$inner,vps$figure,vps$plot)
  sapply(famids,draw.logo)
  popViewport(3)
  
  hc
### The dendrogram from the call to hclust
}
##debug(sublogo.dendrogram)

sublogo <- function
### Draw a sublogo dendrogram for a sequence motif.
(seqs,
### Character vector of DNA or protein sequences (optionally named
### with sequence labels).
 mat=NULL,
### Substitution matrix passed to seqs.to.mat.
 ...
### Other arguments to pass to sublogo.dendrogram (see that help page
### for a full description).
 ){
  sublogo.dendrogram(seqs.to.mat(seqs,mat),...)
}

.result <-
list(dna.identity = list(definition = "dna.identity <- matrix(0,nrow=length(dna.letters),ncol=length(dna.letters),\n                       dimnames=list(dna.letters,dna.letters))", format="",title="dna identity",
    description = "DNA identity substitution matrix."),
     dna.letters = list(format="",title="dna letters",
    definition = "dna.letters <- c(\"*\",\"A\",\"T\",\"G\",\"C\")", 
    description = "Letters in the DNA alphabet, used to auto-detect sequence type"), 
    make.logo.ps = list(definition = "make.logo.ps <- function\n### Create a logo using weblogo, then read it in using grImport\n(helices,\n### Sequences to plot in the logo\n psbase\n### Base filename for the logo postscript and xml files, should be the\n### full path name except for the trailing .ps\n ){\n  psfile <- paste(psbase,'ps',sep='.')\n  xmlfile <- paste(psfile,'xml',sep='.')\n  seq.text <- paste(paste('>',helices,'\\n',helices,sep=''),collapse='\\n')\n  write(seq.text,psbase)\n  execdir <- system.file(\"exec\",package=\"sublogo\")\n  cmd <- paste(\"PATH=\",execdir,\n               \":$PATH seqlogo -c -F EPS -f \",psbase,\n               \"|sed 's/^EndLine/%EndLine/'|sed 's/^EndLogo/%EndLogo/' >\",\n               psfile,sep=\"\")\n  cat(cmd,'\\n')\n  system(cmd)\n  owd <- setwd(tempdir())\n  PostScriptTrace(psfile,xmlfile)\n  setwd(owd)\n  pic <- readPicture(xmlfile)\n  pic\n### Grid picture grob as read using readPicture\n}",
      format="",title="make logo ps",
        description = "Create a logo using weblogo, then read it in using grImport", 
        `item{helices}` = "Sequences to plot in the logo", `item{psbase}` = "Base filename for the logo postscript and xml files, should be the\nfull path name except for the trailing .ps", 
        value = "Grid picture grob as read using readPicture"), 
    read.fasta = list(definition = "read.fasta <- function\n### Read sequences in FASTA format into a named character vector\n(infile\n### Name of the sequence file\n ){\n  tmp <- sapply(strsplit(strsplit(paste('\\n\\n\\n',paste(readLines(infile),collapse='\\n'),sep=''),split='\\n>')[[1]],'\\n'),function(v)c(v[1],paste(v[2:length(v)],collapse='')))\n  seqs <- tmp[2,]\n  names(seqs) <- tmp[1,]\n  blank <- names(seqs)==''\n  names(seqs)[blank] <- seqs[blank]\n  names(seqs) <- gsub(' ','',names(seqs))\n  seqs[seqs!='']\n}",
      format="",title="read fasta",
        description = "Read sequences in FASTA format into a named character vector", 
        `item{infile}` = "Name of the sequence file"),
     seqs.to.mat = list(format="",title="seqs to mat",
        definition = "seqs.to.mat <- function\n### Calculate pairwise differences between sequences using a\n### substitution matrix.\n(seq.vec,\n### DNA or protein sequences.\n subs.mat=NULL){\n### Substitution matrix with dimnames that match the letters used in\n### the sequence data, or a character vector that specifies a common\n### substitution matrix (as defined in the Biostrings package). NULL\n### specifies that we will guess a suitable substitution matrix to\n### match your input sequences (DNA=>identity, protein=>BLOSUM62).\n  if(is.null(names(seq.vec)))names(seq.vec) <- seq.vec\n  chars <- sapply(seq.vec,nchar)\n  seqsum <- table(chars)\n  if(length(seqsum)>1){\n    print(as.data.frame(seqsum))\n    i <- which.max(seqsum)\n    cat(\"Sequences not of length \",names(seqsum)[i],\":\\n\",sep=\"\")\n    rows <- as.integer(names(seqsum)[i])!=chars\n    print(data.frame(chars,name=names(seq.vec),row.names=NULL)[rows,])\n    stop(\"All input sequences must be of the same length.\")\n  }\n  d <- toupper(gsub('[- .]',\"*\",seq.vec[unique(names(seq.vec))]))\n  print(d)\n  letters <- unique(c(unlist(strsplit(d,split='')),dna.letters))\n  ##if dna alignment use simple identity matrix\n  looks.like.dna <- identical(sort(letters),sort(dna.letters))\n  if(is.null(subs.mat))\n    subs.mat <- if(looks.like.dna)dna.identity else \"BLOSUM62\"\n  if(mode(subs.mat)==\"character\"){\n    ex <- substitute(data(M,package=\"Biostrings\"),list(M=subs.mat))\n    eval(ex)\n    subs.mat <- get(subs.mat)\n  }\n  print(subs.mat)\n  N <- length(d)\n  m <- matrix(0,nrow=N,ncol=N,dimnames=list(names(d),names(d)))\n  for(i in 1:N)for(j in 1:i){\n    seqs <- sapply(strsplit(c(d[i],d[j]),split=''),c)\n    entry <- try(apply(seqs,1,function(x)subs.mat[x[1],x[2]]))\n    if(class(entry)==\"try-error\"){\n      print(seqs)\n      stop(\"Sequence difference matrix construction failed.\")\n    }\n    ## subscript out of bounds here usually means bad matrix\n    m[i,j] <- m[j,i] <- -sum(entry)\n  }\n  m <- m-min(m)\n  attr(m,'seqs') <- d\n  print(m[1:min(5,nrow(m)),1:min(5,ncol(m))])\n  m\n### The matrix of distances between each input sequence, with dimnames\n### corresponding to either the sequences, or the sequence names (if\n### they exist)\n}", 
        description = "Calculate pairwise differences between sequences using a\nsubstitution matrix.", 
        `item{seq.vec}` = "DNA or protein sequences.", `item{subs.mat}` = "Substitution matrix with dimnames that match the letters used in\nthe sequence data, or a character vector that specifies a common\nsubstitution matrix (as defined in the Biostrings package). NULL\nspecifies that we will guess a suitable substitution matrix to\nmatch your input sequences (DNA=>identity, protein=>BLOSUM62).", 
        value = "The matrix of distances between each input sequence, with dimnames\ncorresponding to either the sequences, or the sequence names (if\nthey exist)"), 
    sublogo = list(definition = "sublogo <- function\n### Draw a sublogo dendrogram for a sequence motif.\n(seqs,\n### Character vector of DNA or protein sequences (optionally named\n### with sequence labels).\n mat=NULL,\n### Substitution matrix passed to seqs.to.mat.\n ...\n### Other arguments to pass to sublogo.dendrogram (see that help page\n### for a full description).\n ){\n  sublogo.dendrogram(seqs.to.mat(seqs,mat),...)\n}",
      format="",title="sublogo",
        description = "Draw a sublogo dendrogram for a sequence motif.", 
        `item{seqs}` = "Character vector of DNA or protein sequences (optionally named\nwith sequence labels).", 
        `item{mat}` = "Substitution matrix passed to seqs.to.mat.",
        `item{\\dots}` = "Other arguments to pass to sublogo.dendrogram (see that help page\nfor a full description)."), 
    sublogo.dendrogram = list(definition = "sublogo.dendrogram <- function\n### Main function for drawing sublogo dendrograms.\n(M,\n### difference matrix as constructed by seqs.to.mat (although in\n### principle any object with a valid as.dist method could be used)\n main='',\n### plot title\n subtit=NULL,\n### plot subtitle\n base=tempfile(),\n### base file name for temporary logo files\n cutline=150,\n### Distance for cutting the tree. Draw a sublogo for each\n### leaf. Normally you will plot once, then inspect the dendrogram to\n### determine which is a good value for cutline, then plot again using\n### your chosen cutline.\n dend.width=30,\n### Percent of the plot to be occupied by the dendrogram. The logos\n### will be displayed with equal widths on either side.\n cex=1\n### character expansion factor for the dendrogram\n ){\n  hc <- hclust(as.dist(M),method=\"average\")\n  dend <- as.dendrogram(hc)\n  fam <- cutree(hc,h=cutline)[labels(dend)] # order by plotting method\n  famids <- unique(fam)\n  famtab <- data.frame(fam,y=1:length(fam))\n  famtab$seq <- attr(M,'seqs')[rownames(famtab)]\n  fam.nontriv <- sapply(famids,function(i)sum(famtab$fam==i))>1\n  names(fam.nontriv) <- famids\n  if(is.null(subtit))\n    subtit <- paste(nrow(M),\"sequences,\",sum(fam.nontriv),\"families\")\n  xrange <- c(0,1)\n  yrange <- c(0,max(famtab[,'y'])+1)\n  draw.box <- function(i){ # replace with logos\n    subtab <- famtab[famtab[,'fam']==i,]\n    grprange <- range(subtab[,'y'])\n    rect(xrange[1],grprange[1]-0.25,xrange[2],grprange[2]+0.25)\n  }\n  draw.logo <- function(i){\n    ## do not draw sublogo for a family of trivial size\n    if(fam.nontriv[as.character(i)]){ \n      subtab <- famtab[famtab[,'fam']==i,]\n      grprange <- range(subtab[,'y'])\n      tmpfile <- paste(base,i,sep='.')\n      logo <- make.logo.ps(subtab$seq,tmpfile)\n      grid.picture(logo,\n                   x=xrange[1],\n                   y=unit(grprange[1]+0.25,'native'),\n                   height=unit(diff(grprange)-0.5,'native'),\n                   distort=TRUE,\n                   just=c(0,0),\n                   fillText=TRUE)\n    }\n  }\n\n  bottomspace <- 0.6\n  topspace <- 0.4\n  side.percents <- (100-dend.width)/2\n  layout(matrix(1:3,ncol=3),c(side.percents,dend.width,side.percents))\n  par(mai=c(bottomspace,0,topspace,0),cex=1)\n  \n  ## Big summary logo on left\n  plot(xrange,yrange,\n       bty='n',xaxt='n',yaxt='n',ylab='',xlab='',type='n',yaxs='i')\n  biglogo <- make.logo.ps(famtab$seq,paste(base,'0',sep='.'))\n  vps <- baseViewports()\n  pushViewport(vps$inner,vps$figure,vps$plot)\n  grid.picture(biglogo,\n               y=unit(0,'native'),\n               height=unit(length(fam),'native'),\n               just=c(0.5,0),\n               exp=0,\n               distort=TRUE,\n               fillText=TRUE)\n  popViewport(3)\n  \n  ## Dendrogram in middle\n  par(mai=c(bottomspace,0,topspace,\n        max(strwidth(colnames(M),'inches',\n                     cex))/6*5),\n      family='mono')\n  par(xpd=NA)\n  plot(dend,h=TRUE,edgePar=list(lwd=2),nodePar=list(lab.cex=cex,pch=\"\"))\n  par(family=\"\")\n  segments(cutline,1,cutline,length(fam))\n  ##axis(3,cutline,lty=0,line=0)\n  \n  ## Title in the middle\n  title(main,line=0.5)\n  mtext(subtit,line=-0.7,cex=1)\n\n  # Sublogos on the right side\n  par(mai=c(bottomspace,0,topspace,0))\n  plot(xrange,yrange,\n       bty='n',xaxt='n',yaxt='n',ylab='',xlab='',type='n',yaxs='i')\n  vps <- baseViewports()\n  pushViewport(vps$inner,vps$figure,vps$plot)\n  sapply(famids,draw.logo)\n  popViewport(3)\n  \n  hc\n### The dendrogram from the call to hclust\n}",
      format="",title="sublogo dendrogram",
        description = "Main function for drawing sublogo dendrograms.", 
        `item{M}` = "difference matrix as constructed by seqs.to.mat (although in\nprinciple any object with a valid as.dist method could be used)", 
        `item{main}` = "plot title", `item{subtit}` = "plot subtitle", 
        `item{base}` = "base file name for temporary logo files", 
        `item{cutline}` = "Distance for cutting the tree. Draw a sublogo for each\nleaf. Normally you will plot once, then inspect the dendrogram to\ndetermine which is a good value for cutline, then plot again using\nyour chosen cutline.", 
        `item{dend.width}` = "Percent of the plot to be occupied by the dendrogram. The logos\nwill be displayed with equal widths on either side.", 
        `item{cex}` = "character expansion factor for the dendrogram", 
        value = "The dendrogram from the call to hclust"))

"vectorElements<-" <- function(
		### adds or replaces value in vec
		vec			##<< a named vector
		,value		##<< a named vector of same mode as vec
){
}

.result <- 
		list(`vectorElements<-` = list(definition = "\"vectorElements<-\" <- function(\n\t\t### adds or replaces value in vec\n\t\tvec\t\t\t##<< a named vector\n\t\t,value\t\t##<< a named vector of same mode as vec\n){\n}",  
						description = "adds or replaces value in vec", `item{vec}` = "a named vector",  
						`item{value}` = "a named vector of same mode as vec", format = "",  
						title = "vectorElements<-")) 

silly.example <- function
### this function does nothing in particular and does it very well
(
 ##title<<Simple function arguments
 first,         ##<< the first argument with a multi-line description
 ## which I really have to put here rather than explaining in the details.
 second=        ##<< the second argument with a list default value
 ## and descriptions of each of the elements
 ##describe<<
 list(this="that", ##<< whichness
      the="other", ##<< of the
      rhubarb="stew", ##<< why
      foo="bar"),
 ##end<<
 third ##<< an argument that does nothing
 )
{
  ##description<<why should I add to description?
  ##details<<
  ## if second is TRUE then first is returned
  if ( second ){
    ##alias<<Long silly alias
    res <- first
  } else {
    ##details<<
    ## if second is not TRUE then a list is returned
    ##describe<<The contents of the list are:
    res <- list(x=7, ##<< x coordinate
                z= ##<< z describes everything else
                ##describe<<
                list(colour=green, ##<< colour of line
                     width=2),     ##<< width of line
                ##end<<
                ## and this line should get into documentation for z
                y=10)##<< y coordinate
  }
  ##note<< a note
  ##references<< a reference
  ##seealso<< \code{\link{Silly-class}}
  ##keyword<<documentation utilities
  invisible(res)
### invisible something not unrelated to first
}

setClass("Silly", # S4 classes can be documented as well
### The Silly class does nothing much either
         ##details<< Put what you like in documentation details,
         ## but ideally reference construction methods.
         representation(forwards="function", ##<< forward operation
                        reverse="function", ##<< how to go backward
                        crashes="integer") ##<< how many crashes
         ) ##<< this comment is ignored as it is outside setClass expression

.result <- 
 list(silly.example = list(definition = "silly.example <- function\n### this function does nothing in particular and does it very well\n(\n ##title<<Simple function arguments\n first,         ##<< the first argument with a multi-line description\n ## which I really have to put here rather than explaining in the details.\n second=        ##<< the second argument with a list default value\n ## and descriptions of each of the elements\n ##describe<<\n list(this=\"that\", ##<< whichness\n      the=\"other\", ##<< of the\n      rhubarb=\"stew\", ##<< why\n      foo=\"bar\"),\n ##end<<\n third ##<< an argument that does nothing\n )\n{\n  ##description<<why should I add to description?\n  ##details<<\n  ## if second is TRUE then first is returned\n  if ( second ){\n    ##alias<<Long silly alias\n    res <- first\n  } else {\n    ##details<<\n    ## if second is not TRUE then a list is returned\n    ##describe<<The contents of the list are:\n    res <- list(x=7, ##<< x coordinate\n                z= ##<< z describes everything else\n                ##describe<<\n                list(colour=green, ##<< colour of line\n                     width=2),     ##<< width of line\n                ##end<<\n                ## and this line should get into documentation for z\n                y=10)##<< y coordinate\n  }\n  ##note<< a note\n  ##references<< a reference\n  ##seealso<< \\code{\\link{Silly-class}}\n  ##keyword<<documentation utilities\n  invisible(res)\n### invisible something not unrelated to first\n}",
        format="",
     description = "this function does nothing in particular and does it very well\nwhy should I add to description?",  
     value = "invisible something not unrelated to first", title = "Simple function arguments",  
     `item{first}` = "the first argument with a multi-line description\nwhich I really have to put here rather than explaining in the details.",  
     `item{second}` = "the second argument with a list default value\nand descriptions of each of the elements\\describe{\n\\item{this}{whichness}\n\\item{the}{of the}\n\\item{rhubarb}{why}\n}",  
     `item{third}` = "an argument that does nothing", details = "if second is TRUE then first is returned\n\nif second is not TRUE then a list is returned\n\nThe contents of the list are:\\describe{\n\\item{x}{x coordinate}\n\\item{z}{z describes everything else\\describe{\n\\item{colour}{colour of line}\n\\item{width}{width of line}\n}\nand this line should get into documentation for z}\n\\item{y}{y coordinate}\n}",  
     alias = "Long silly alias", note = "a note", references = "a reference",  
     seealso = "\\code{\\link{Silly-class}}", keyword = "documentation}\n\\keyword{utilities"),  
     `Silly-class` = list(title = "S4 classes can be documented as well",
       format="",
         description = "The Silly class does nothing much either",  
         details = "Put what you like in documentation details,\nbut ideally reference construction methods.",  
         `item{forwards}` = "forward operation", `item{reverse}` = "how to go backward",  
         `item{crashes}` = "how many crashes", `section{Objects from the Class}` = "Put what you like in documentation details,\nbut ideally reference construction methods.",  
         seealso = "", alias = "Silly")) 

#{{{ A test of inlinedocs with some difficult items
'@
To compile the package, make:
<code R>
library(inlinedocs)
package.skeleton.dx("~/Documents/Pgm/Rforge/inlinedocs/pkg/inlinedocs/scratch/inlinedocsTest", namespace = TRUE)
</code>
<<>>='
#}}}


"%!in%" <- function ( # Look which elements are absent from a table
### Check which ones of the tested values are absent from a reference table.
### This is the opposite as %in% operator in base package.
x,		##<< a vector of values to check
table	##<< a vector of items of the same type as 'x', to be checked
){
	return(!x %in% table)
	### A vector of logical of the same length as 'x', indicating which items
	### are not in 'table'
}

"[<-.ex" <- function ( # Replace an item in an 'ex' object
x,			##<< an 'ex' object
which = 1,	##<< which element of the 'ex' object to replace
value		##<< the value to use for replacement
){
	# This is not much useful, but it is used to test a special case of usage!
	x <- as.character(x)
	x[which] <- value
	class(x) <- c("ex", "character")
	return(x)
	### 'x' is returned, with 'value' replacing the 'which'th element
}

# Note: to embed examples in objects as 'ex' attribute:
"ex<-" <- function (  # Embed examples code in an object
x,		##<< an object
value	##<< a character string containing code for examples
){
	# Add 'value' as a 'ex' attribute to 'x', after coercing to an 'ex' object
	attr(x, "ex") <- structure(as.character(value), class = c("ex", "character"))
	return(x)
	### The initial object 'x' with attribute 'ex' added or changed to 'value'
}

"is.ex" <- function (	# Test if an object is of 'ex' class, or possesses an 'ex' attribute
x		##<< an object to test
){
	return(inherits(x, 'ex') || !is.null(attr(x, "ex")))
	### Return \code{TRUE} if 'x' inherits of class 'ex' or has an 'ex' attribute,
	### \code{FALSE} otherwise.
}

"ex" <- function (	# Extract and run the 'ex' attribute from an object (or run the 'ex' object itself)
x,				##<< an object possibly containing an 'ex' attribute, or of class 'ex'
runIt = TRUE,	##<< do we run the examples?
...				##<< further arguments passed to source()
){
	if (inherits(x, 'ex')) {
		res <- x
	} else res <- attr(x, "ex")
	if (is.null(res)) {
		cat("No examples found\n")
		return(invisible(FALSE))
	} else {
		res <- structure(as.character(res), class = c("ex", "character"))
		if (isTRUE(runIt)) {
			txt <- textConnection(res)
			on.exit(close(txt))
			cat("Examples for '", deparse(substitute(x)), "'\n", sep = "")
			source(txt, echo = TRUE, ...)
		}
		return(invisible(res))
	}
	### The extracted 'ex' object
}

"print.ex" <- function (	# Print method of an 'ex' object
x,		##<< an object that has a non empty 'ex' attribute
...		##<< further arguments to pass to print()
){
	if (!is.ex(x)) stop("'x' must be an 'ex' object")
	cat("Examples:\n")
	cat(x, "\n")
	return(invisible(x))
}

"Combine" <- function (x, y, ...) # Combine lists or character strings
	UseMethod("Combine")

"Combine.character" <- function ( # Combine character strings by pasting them together
x,	##<< a first character vector to combine
y,	##<< a second character vector to combine
...	##<< further arguments (not used yet)
){
	res <- paste(x, y, sep = "\n")
	return(res)
	### The comment of the return value
	### on two lines...
	#{{{examples
	a <- c("A", "B", "C")
	b <- c("A", "C", "D")
	Combine(a, b)
	#}}}examples
}

"Combine.list" <- structure(function( # Combine lists by adding elements or adding to existing elements
x,		##<< a first list to combine
y,		##<< a second list to combine
		##   with the previous one 
...		##<< further arguments (not used yet)
#{{{doc
#S3method<<Combine
##description<< This is a more extensive description of what the function
##				is supposed to do... It typically spans on several lines
##				and the intelligent formatting of Komodo is working very
##				nicely in this case (use Shift+Return)
##
##note<< This is just to test inlinedocs extended features inside SciViews
##		 Komodo, including formattings like \eqn{n}th power.
##
##references<< \url{http://inlinedocs.r-forge.r-project.org}
##
##seealso<< \code{\link{combine}}
#}}}doc
){
	toadd <- !names(y) %in% names(x)
	toup <- names(y)[names(y) %in% names(x)]
	x[names(y)[toadd]] <- y[toadd]
	for (up in toup)
		x[[up]] <- combine(x[[up]], y[[up]])
	return(x)
	### A list that combines both 'x' and 'y' lists
},
# Here is how to attach examples code to an object
ex = function () {
	# Simple example of combining two lists
	a <- list(x = "hello", y = "world")
	b <- list(x = "John", z = "everybody")
	Combine(a, b)
})

\name{silly.example}
\alias{silly.example}
\alias{Long silly alias}
\title{Simple function arguments}
\description{this function does nothing in particular and does it very well
why should I add to description?}
\usage{silly.example()}
\value{always 5}
\author{Toby Dylan Hocking}

\name{inner.function-package}
\Rdversion{1.1}
\alias{inner.function-package}
\docType{package}
\title{test package for inner functions}
\description{test package for inner functions...}
\details{
\tabular{ll}{Package: \tab inner.function\cr
Maintainer: \tab tdh\cr
Author: \tab tdh\cr
Version: \tab 1.0\cr
License: \tab GPL-3\cr
Title: \tab test package for inner functions\cr
Description: \tab test package for inner functions...\cr}
}
\author{tdh}
\references{
}
\keyword{ package }
\seealso{
}
\examples{}

\name{outer.function}
\Rdversion{1.1}
\alias{outer.function}
\title{outer function}
\description{this is a high-level package function that will be exported for all of your users.}
\usage{
outer.function(a, b)
}
\arguments{
  \item{a}{first arg}
  \item{b}{second arg}
}
\details{
}
\value{Return value of outer.function.}
\references{
}
\author{tdh}
\note{
}


\seealso{
}
\examples{}

\name{extract.docs.fun}
\Rdversion{1.1}
\alias{souped up function extraction}
\alias{extended keyword function commenting}
\title{ Extract documentation from a function}
\description{Given a function, return a list describing inline documentation in the source of that function (relies on source attr).}
\usage{
extract.docs.fun(fun)
}
\arguments{
  \item{fun}{The function to examine.}
}
\details{
For simple functions/arguments, the argument may also be documented by
appending ##<< comments on the same line as the argument. For those who
wish to become confused, any following ### comment lines will be appended.


Additionally, contiguous sections of ## comment lines beginning with
<<xxx (where xxx is one of the "other" fields: alias, details, keyword,
references, author, note, seealso or value) are accumulated and inserted in
the relevant part of the .Rd file.

In the case of value, the extra information is appended to that from
any final ### comment lines.

Each separate extra section appears as a new paragraph
except that empty sections (no matter how many lines) are ignored.}
\value{Named list of character strings extracted from comments. For each name N we will look for N\{...\} in the Rd file and replace it with the string in this list (implemented in modify.Rd.file).}
\references{
}
\author{Toby Dylan Hocking <toby.hocking@etu.upmc.fr>}
\note{Alias extras are automatically split at new lines.

Keyword extras are auto-split at white space.}


\seealso{
}
\examples{}
\keyword{documentation}
\keyword{utilities}

\name{fun}
\alias{fun}
\title{fun}
\description{A test function with an example.}
\usage{fun()}
\author{Inlinedocs development team
<inlinedocs-support@lists.r-forge.r-project.org>}
\examples{
owd <- setwd("~")
testPackagePath <- file.path( system.file(package="minimalErrorPkg"),"silly" )
file.copy(testPackagePath,".",recursive=TRUE)
## check the package to see if it passes without WARNINGs
cmd <- sprintf("\%s CMD check --as-cran silly",file.path(R.home("bin"), "R"))
print(cmd)
checkLines <- system(cmd,intern=TRUE)
warnLines <- grep("WARNING",checkLines,value=TRUE)
if(length(warnLines)>0){
  writeLines(checkLines)
  cat("\n\nLines with WARNING:\n")
  print(warnLines)
  stop("WARNING encountered in package check!")
}
setwd(owd)
}

\name{test}
\Rdversion{1.1}
\alias{Iolanthe}
\title{ simple function arguments}
\description{## this function does nothing in particular and does it very well}
\usage{
test(first, second = TRUE)
}
\arguments{
  \item{first}{the first argument}
  \item{second}{the second argument}
}
\details{
if second is TRUE then first is returned


if second is not TRUE then first is negated}
\value{invisible something not unrelated to first}
\references{
}
\author{Toby Dylan Hocking <toby.hocking@etu.upmc.fr>}
\note{
}


\seealso{
}
\examples{}
